LMAXCOLS    equ 50  ; level size in bytes
LMAXROWS    equ 20
	IFD ti89
XMAXVIEW    equ 160 ; viewport size
YMAXVIEW    equ  80 ;
	ENDIF
	IFND ti89
XMAXVIEW    equ 160 ; viewport size
YMAXVIEW    equ 128 ;
	ENDIF

; Stack organization
; A6
;     0..  127 : Variables
;   128..  639 : LemTab
;   640..  895 : SDLemTab
;   896.. 1407 : AttribLevel (512 bytes, but there are only 240 tiles ;-) A.P.
;  1408.. 2407 : TLevel : the level
;  2408.. 3431 : Animated tiles
;  3432.. 11431 : lplane1

; differencies between ti92 & ti92+
;              ti92+              |      ti92
; gray4lib   external             |    internal
; plane0    allocated by gray4lib |   allocated by initgr
;

LPLANESIZE  equ 8*LMAXROWS*LMAXCOLS
 
LemTab      equ  128
SDLemTab    equ  640
AttribLevel equ  896
TLevel      equ 1408
AnimTiles   equ 2408
lplane      equ 3432
lplane1     equ 3432
lplane0     equ 11432
STACK       equ 11432

LLemAct     equ 0
LLemX       equ 2
LLemTime    equ 4
LLemY       equ 5
LLemCnt     equ 6
LLemCnt2    equ 8
LLemDir     equ 9

SSDLemPut   equ 0
SSDLemXc    equ 1
SSDLemXi    equ 2
SSDLemY     equ 3
SSDLemCnt   equ 4

;
; Timer/int 0 variables
;

ntick          equ  0  ; dc.w 0
nphase         equ  2  ; dc.w 0
cnt            equ  4  ; dc.w 0
ticks          equ  6  ; dc.w 0
ctick          equ  7
plane0         equ  8  ; dc.l 0  ; 4 bytes var
table          equ 12  ; ds.w 3  ; 6 bytes
time           equ 18  ; dc.w 0  ; two bytes
handle         equ 20  ; dc.w 0  ; handle to the allocated memory
old_int_1      equ 22  ; dc.l 0   ; Pointer to previous interrupt (Auto-Int-1)
old_int_5      equ 26
hlplane0       equ 30  ; dc.l 0  ;
plane1         equ 34  ; dc.l 0  ; 4 bytes var

;
; Keyboard/Movement variables
;

Xoff           equ 38  ; dc.w 0  ; level x offset in bytes
Yoff           equ 40  ; dc.w 0  ; level y offset in pixels
XCross         equ 42  ; dc.w 0  ; x pos of cross in dpixels (rel to upper left corner
YCross         equ 44  ; dc.w 0  ; y pos of cross in pixels   of the displayed level)
XCrossTrue     equ 46  ; dc.w 0  ; x pos of cross in dpixels (rel to upper left corner
YCrossTrue     equ 48  ; dc.w 0  ; y pos of cross in pixels   of the whole level)
CursorMoved    equ 50  ; dc.b 0  ; flag to remember when to speed up or halt cursor
CursorSpeed    equ 51  ; dc.b 0  ; speed in dpixels
Command        equ 52  ; dc.b 0  ; the selcted lemmings command (F1..F8 -> 0..7)
GiveCommand    equ 53  ; dc.b 0  ; list number of the lemming to give the above
KeyStat        equ 54  ; dc.w 0

;
; Lemm disp variables
;

NuOfLems       equ 56  ; dc.b 0  ; number of lemmings in the level
LemCurrent     equ 57  ; dc.b 0  ; number of current lemming in DoLemmings
LemTarget      equ 58  ; dc.w 0  ; number of lemming under cross (negative = none)
LemAct         equ 60  ; dc.w 0  ; Action of the lemming :
LemX           equ 62  ; dc.w 0  ; x pos of lemming in dpixels
LemY           equ 64  ; dc.w 0  ; y pos of lemming in pixels
LemCnt         equ 66  ; dc.w 0  ; positiv: lemming waits to come into level
LemDir         equ 68  ; dc.w 0  ; speed and direction of lemming in dpixels (-1 or 1)
LemCnt2        equ 70  ; dc.b 0  ; arbitrary counter, saved as upper byte of LemDir

;
; Animation variables
;

anit           equ 80  ; dc.w 0
GaSpX          equ 82  ; dc.w 0   ; x-pos in bytes
GaSpY          equ 84  ; dc.w 0   ; y-pos in pixels
Chain          equ 86

LemSelected    equ 88
AttribPtr      equ 90
menupos        equ 94
;
; Game status
;
curlvl         equ 96  ; dc.w 0      ; current level
gstatus        equ 98  ; dc.w 0      ; game status

;
; lemming and command counters
;

CmdClimb       equ 100 ; dc.b 0
CmdBomb        equ 101 ; dc.b 0
CmdBuild       equ 102 ; dc.b 0
CmdMine        equ 103 ; dc.b 0
CmdFloat       equ 104 ; dc.b 0
CmdStop        equ 105 ; dc.b 0
CmdBash        equ 106 ; dc.b 0
CmdDig         equ 107 ; dc.b 0

LemsTotal      equ 108 ; dc.b 0
LemsIn         equ 109 ; dc.b 0
LemsOut        equ 110 ; dc.b 0
LemsOff        equ 111 ; dc.b 0

LemSpawnInit   equ 112 ; dc.b 0  ; time ticks for spawning the next lemming
LemSpawn       equ 113 ; dc.b 0  ; temp counter for var above

