; ****************************************************************************
;
;                             L E M M I N G S
;
;                               a ti port by
;
;               Stephan Effelsberg b012414@dvz.fh-koeln.de
;               Alejandro Paz Schmidt psys@cotelco.com.ar
;
; Last modification 9/3/00
;
; ****************************************************************************

; choose one from below
;ti92    equ 1
;ti92plus    equ 1
ti89    equ 1

;DEBUGKEY equ 1


    IFD ti92
        include "tios.h"
    ENDIF
    IFD ti92plus ; [tie] too ;-)
        include "doorsos.h"
        include "gray4lib.h"
        xdef _ti92plus
    ENDIF
    IFD ti89
        include "doorsos.h"
        include "gray4lib.h"
        xdef _ti89
	xdef _exit
    ENDIF

        include "equ.h"
        include "levels.h"
        include "mysh.asm" ; a modified shrinklib w/o heapalloc
WalkAnim:
        incbin  "wanim.pln"

        include "charset2.h"
quadsdta:
        incbin  "quad.pln"
lemgrp:
        IFD ti89
        incbin  "lemgrp89.pak"
        ENDIF
        IFND ti89
        incbin  "lemgrp.pak"
        ENDIF

        xdef   _main
        xdef   _comment

_main:
    IFD ti92
        lea     -STACK(a7),a7   ; saves room on the stack
        lea     mvar+2(pc),a1
        move.l  a7,(a1)
        move.l  a7,a6   ; variables on stack
    ENDIF
    IFD DEBUGKEY
debkeyloop:
        clr.w   d0                       ; to debug, don't shrink it
    IFND ti92
        tst.w   doorsos::kb_globals+$1C
    ENDIF
    IFD ti92
        tst.w   tios::kb_globals+$1C
    ENDIF
        beq     debkeyloop
    ENDIF

        bsr     initgr4lib        ; int and grayscale, self implementation
        beq     Exit1             ; if it fails

StartOver:

	move.w	#-1,d0
        bsr     GetLibInfoD0
StartOver_1:
        clr.w   curlvl(a6)        ; starts form level 0
        bsr     Intro
NextLevel:
        clr.b   gstatus(a6)       ; game in progress
        bsr     extractlvl

        bsr     prescr
        bsr     InitInfo          ; the 8 boxes on the left/bottom of the screen
        clr.w   anit(a6)
	clr.b	LemSelected(a6)
	clr.w	menupos(a6)
MainLoop:
        tst.b   ticks(a6)
        beq     MainLoop
f0_l1:
        clr.b   ticks(a6)       ; event marker

        bsr     DoKeys
        btst.b  #5,KeyStat(a6)  ; freezes the action until the shift key is released
        bne.s   f0_l2
        bsr     DoLemming
        bsr     SprDispInit
        bsr     updateani
        bsr     ShowScreen      ; and ShowCross
        bsr     SprDisp
f0_l2:
        bsr     showvar         ; incl. TargetName and Menu
        moveq   #1,d1
        cmp.b   #3,gstatus(a6)  ; time is up ?
        beq.s   f0_l5
        tst.b   gstatus(a6)
        bmi.s   Exit            ; if Esc was pressed in the game

	bsr	CheckFinished
	bpl	MainLoop
        ;
        ; level finished

        bsr     GetLibInfo
        move.b  LLemNe(a2),d0
        clr.w   d1              ; out of lems
        cmp.b   LemsIn(a6),d0
        bhi.s   f0_l5           ; out of lems
        addq.w  #1,curlvl(a6)
	move.w	curlvl(a6),d0
	lea	lemlvl@0001,a0
	cmp.w	(a0),d0
	bcs.s   f0_l4
	move.w  d0,(a0)
f0_l4:
        moveq   #-1,d0
        bsr     GetLibInfoD0
        cmp.w   curlvl(a6),d0
        beq.s   f0_l6
        bra     NextLevel
f0_l6:
	clr.w	curlvl(a6)
	moveq.w	#2,d0
f0_l5:
        bsr     tupscr
        bra     NextLevel
Exit:
        bsr     exitgr4lib      ; greyscale off and restoring int
Exit1:
    IFD ti92
        lea     STACK(a7),a7    ; free stack
    ENDIF
        rts

    IFND ti92
_exit:
        move.w  mvar(pc),-(sp)  ; !@
        jsr     doorsos::HeapFree
        lea     2(a7),a7
	rts
    ENDIF

; ***************************************************************************
; ***************************************************************************
;
; Keyboard Stuff
;
;
; DoKeys - 'scans' the keyboard and updates the variables
;
; very different versions for 89 and 92, 2 large IFDs are used
;
	IFND ti89

DoKeys:
        bsr     ScanKeys
        move.b  KeyStat(a6),d0
        tst.b   d0
        bne.s   f2_l3
        move.b  #1,CursorSpeed(a6)
        bra     f2_l50
f2_l3:
	btst	#7,d0 ; Apps
        beq.s   f2_l4
	bsr	SelectNextLem
f2_l4:
	clr.b	CursorMoved(a6)
        clr.w   d1
        move.b  CursorSpeed(a6),d1

f2_l5:  btst    #3,d0 ; rigth
        beq.s   f2_l10
        ; right
f2_l6:  add.w   d1,XCross(a6)
        move.b  #1,CursorMoved(a6)

        cmp.w   #XMAXVIEW-8,XCross(a6)
        bge.s   f2_l7   ; jump if we need to move the view
        bra.s   f2_l10 ; !
f2_l7:  ; the level have LMAXCOLS*8 pixels, we show only XMAXVIEW pixels
        move.w  #XMAXVIEW-8,XCross(a6)
        cmp.w   #LMAXCOLS-XMAXVIEW/8,Xoff(a6)
        beq.s   f2_l10  ; don't move
        addq.w  #2,Xoff(a6)

f2_l10:   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        btst    #1,d0 ; left
        beq.s   f2_l15

f2_l11: sub.w   d1,XCross(a6)
        bpl.s   f2_l12
        clr.w   XCross(a6)
f2_l12: move.b  #2,CursorMoved(a6)
        ; left / izq
        tst.w   XCross(a6)
        beq.s   f2_l14
        bra.s   f2_l15
f2_l14: tst.w   Xoff(a6)
        beq.s   f2_l15  ; don't move
        subq.w  #2,Xoff(a6)

f2_l15:   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        btst    #2,d0 ; up
        beq.s   f2_l20

f2_l16: sub.w   d1,YCross(a6)
        bpl.s   f2_l17
        clr.w   YCross(a6)         ; fixes position if neg
f2_l17: move.b  #3,CursorMoved(a6)
        ; up / arriba
        tst.w   YCross(a6)
        bne.s   f2_l20
f2_l18: subq.w  #8,Yoff(a6)
        tst.w   Yoff(a6)
        bpl.s   f2_l20
	clr.w   Yoff(a6)

f2_l20:   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        btst    #4,d0 ; down
        beq.s   f2_l25

f2_l21: add.w   d1,YCross(a6)

        move.b  #4,CursorMoved(a6)
        ; down / abajo
        cmp.w   #YMAXVIEW-8,YCross(a6) ; if we need to move the view
        bge.s   f2_l22
        bra.s   f2_l25
f2_l22: move.w  #YMAXVIEW-8,YCross(a6)
        addq.w  #8,Yoff(a6)
        cmp.w   #LMAXROWS*8-YMAXVIEW,Yoff(a6)
        bcs.s   f2_l25
        move.w  #LMAXROWS*8-YMAXVIEW,Yoff(a6)

f2_l25:
        addq.b  #3,CursorSpeed(a6)
        tst.b   CursorMoved(a6)
        bne.s   f2_l26
        move.b  #1,CursorSpeed(a6)
f2_l26:
        move.b  CursorSpeed(a6),d1
	cmp.b   #16,d1
        bcs.s   f2_l27
	move.b  #16,CursorSpeed(a6)
f2_l27:
        btst    #6,d0 ; tecla exit
        bne.s   f2_l99
f2_l50:
        move.w  Xoff(a6),d0
        lsl.w   #3,d0
        add.w   XCross(a6),d0   ; XCross is in pixels
        lsr.w   #1,d0           ; XCrossTrue in dpixels
        move.w  d0,XCrossTrue(a6)
        move.w  Yoff(a6),d0
        add.w   YCross(a6),d0
        move.w  d0,YCrossTrue(a6)

        move.b  KeyStat+1(a6),d1
        move.w  #7,d7
f2_l52:
        lsl.b   #1,d1
        dbcs    d7,f2_l52
        tst.b   d7                     d7 now contains f-key number 0..7 or $ff
        bmi.s   f2_l54
        clr.w   d2
        move.b  Command(a6),d2
        bsr     cquad   ; ClearQuad
        clr.w   d2
        move.b  d7,d2
        move.b  d2,Command(a6)
        bsr     pquad   ; PutQuad
f2_l54:
       ; check if command key (hand) is pressed
        move.b  #$80,GiveCommand(a6)          ; neg = give command to no lemming
        btst    #0,KeyStat(a6)                ; hand
        beq.s   f2_l56
        move.b  LemTarget(a6),GiveCommand(a6) ; give command to current target
f2_l56:
        btst    #5,KeyStat(a6)                ; clear
        beq.s   f2_l57
	move.b  #1,Chain(a6)
f2_l57:
        rts

f2_l99: move.b  #$ff,gstatus(a6)
        rts             ; exits to tios

	ENDIF



	IFD ti89
	
DoKeys:
        bsr     ScanKeys
        move.b  KeyStat(a6),d0
        tst.b   d0
        bne.s   f2_l3
        move.b  #1,CursorSpeed(a6)
        bra     f2_l27
f2_l3:
	btst	#6,d0 ; diamond
        beq.s   f2_l4
	bsr	SelectNextLem
f2_l4:
	btst	#5,KeyStat(a6)
	bne	f2_l27
	clr.b	CursorMoved(a6)
        clr.w   d1
        move.b  CursorSpeed(a6),d1

f2_l5:  btst    #3,d0 ; rigth
        beq.s   f2_l10
        ; right
f2_l6:  add.w   d1,XCross(a6)
        move.b  #1,CursorMoved(a6)

        cmp.w   #XMAXVIEW-8,XCross(a6)
        bge.s   f2_l7   ; jump if we need to move the view
        bra.s   f2_l10 ; !
f2_l7:  ; the level have LMAXCOLS*8 pixels, we show only XMAXVIEW pixels
        move.w  #XMAXVIEW-8,XCross(a6)
        cmp.w   #LMAXCOLS-XMAXVIEW/8,Xoff(a6)
        beq.s   f2_l10  ; don't move
        addq.w  #2,Xoff(a6)

f2_l10:   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        btst    #1,d0 ; left
        beq.s   f2_l15

f2_l11: sub.w   d1,XCross(a6)
        bpl.s   f2_l12
        clr.w   XCross(a6)
f2_l12: move.b  #2,CursorMoved(a6)
        ; left / izq
        tst.w   XCross(a6)
        beq.s   f2_l14
        bra.s   f2_l15
f2_l14: tst.w   Xoff(a6)
        beq.s   f2_l15  ; don't move
        subq.w  #2,Xoff(a6)

f2_l15:   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        btst    #0,d0 ; up
        beq.s   f2_l20

f2_l16: sub.w   d1,YCross(a6)
        bpl.s   f2_l17
        clr.w   YCross(a6)         ; fixes position if neg
f2_l17: move.b  #3,CursorMoved(a6)
        ; up / arriba
        tst.w   YCross(a6)
        bne.s   f2_l20
f2_l18: subq.w  #8,Yoff(a6)
        tst.w   Yoff(a6)
        bpl.s   f2_l20
	clr.w   Yoff(a6)

f2_l20:   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        btst    #2,d0 ; down
        beq.s   f2_l25

f2_l21: add.w   d1,YCross(a6)

        move.b  #4,CursorMoved(a6)
        ; down / abajo
        cmp.w   #YMAXVIEW-8,YCross(a6) ; if we need to move the view
        bge.s   f2_l22
        bra.s   f2_l25
f2_l22: move.w  #YMAXVIEW-8,YCross(a6)
        addq.w  #8,Yoff(a6)
        cmp.w   #LMAXROWS*8-YMAXVIEW,Yoff(a6)
        bcs.s   f2_l25
        move.w  #LMAXROWS*8-YMAXVIEW,Yoff(a6)

f2_l25:
        addq.b  #3,CursorSpeed(a6)
        tst.b   CursorMoved(a6)
        bne.s   f2_l26
        move.b  #1,CursorSpeed(a6)
f2_l26:
        move.b  CursorSpeed(a6),d1
	cmp.b   #16,d1
        bcs.s   f2_l27
	move.b  #16,CursorSpeed(a6)
f2_l27:
        btst    #0,KeyStat+1(a6) ; tecla exit
        bne     f2_l99
f2_l50:
        move.w  Xoff(a6),d0
        lsl.w   #3,d0
        add.w   XCross(a6),d0   ; XCross is in pixels
        lsr.w   #1,d0           ; XCrossTrue in dpixels
        move.w  d0,XCrossTrue(a6)
        move.w  Yoff(a6),d0
        add.w   YCross(a6),d0
        move.w  d0,YCrossTrue(a6)

	btst	#5,KeyStat(a6)
	bne.s	f2_l51
	; menu down
	subq.w	#4,menupos(a6)
	bpl.s	f2_l54
	clr.w	menupos(a6)
	bra.s	f2_l54
f2_l51:
	; menu up
	addq.w	#4,menupos(a6)
	cmp.w	#12,menupos(a6)
	bcs.s	f2_l52
	move.w	#12,menupos(a6)
f2_l52:
        move.b  Command(a6),d2	; old command
	move.b	d2,d3		; new command
	btst	#1,KeyStat(a6)  ; left
	beq.s	f2_l53
	subq.b	#1,d3
	bra	f2_l531
f2_l53:
	btst	#3,KeyStat(a6)  ; right
	beq.s	f2_l54
	addq.b	#1,d3
f2_l531:
	and.b	#7,d3
        bsr     cquad   ; ClearQuad
	move.b	d3,d2
        move.b  d2,Command(a6)
        bsr     pquad   ; PutQuad

f2_l54:
       ; check if command key (2nd) is pressed
        move.b  #$80,GiveCommand(a6)          ; neg = give command to no lemming
        btst    #4,KeyStat(a6)                ; 2nd
        beq.s   f2_l56
        move.b  LemTarget(a6),GiveCommand(a6) ; give command to current target
f2_l56:
        btst    #7,KeyStat(a6)                ; clear
        beq.s   f2_l57
	move.b  #1,Chain(a6)
f2_l57:
        rts

f2_l99: move.b  #$ff,gstatus(a6)
        rts             ; exits to doors(os)

	ENDIF



SelectNextLem:
	movem.l	d0-d3/a0,-(sp)
	lea	LemTab(a6),a0
	clr.w	d0
	move.b	LemSelected(a6),d0
	; skip the current selection
	addq.b	#1,d0
	cmp.b	LemsTotal(a6),d0
	bne.s	SNL0
	clr.w	d0
SNL0:
	move.b	d0,LemSelected(a6)
	bra.s	SNL1_skip
	; select next lemming
SNLNext:
	addq.b	#1,d0
	cmp.b	LemsTotal(a6),d0
	bne.s	SNL1
	clr.w	d0
SNL1:
	cmp.b	LemSelected(a6),d0
	beq	SNLExit
SNL1_skip:
	move.w	d0,d2
	mulu	#10,d2
	tst.w	LLemAct(a0,d2.w)
	beq.s	SNLNext
	bmi.s	SNLNext

	; found a lemming
	move.b	d0,LemSelected(a6)
	move.w	LLemX(a0,d2.w),d0
	clr.w	d1
	move.b	LLemY(a0,d2.w),d1
	
	move.w	d0,d2
	move.w	d1,d3
	
	; calc Xoff
	lsr.w	#3,d2
	lsl.w	#1,d2
	sub.w	#XMAXVIEW/16,d2
	bpl.s	SNL2
	clr.w	d2
SNL2:
	cmp.w	#LMAXCOLS-XMAXVIEW/8,d2
	bcs.s	SNL3
	move.w	#LMAXCOLS-XMAXVIEW/8,d2
SNL3:
	move.w	d2,Xoff(a6)

	; calc Yoff
	sub.w	#YMAXVIEW/2,d3
	bpl.s	SNL4
	clr.w	d3
SNL4:
	cmp.w	#LMAXROWS*8-YMAXVIEW,d3
	bcs.s	SNL5
	move.w	#LMAXROWS*8-YMAXVIEW,d3
SNL5:
	move.w	d3,Yoff(a6)

	; calc X/YCross
	lsl.w	#2,d2
	sub.w	d2,d0
	add.w	d0,d0
	bpl.s	SNL6
	clr.w	d0
SNL6:
	cmp.w	#XMAXVIEW-8,d0
	bcs.s	SNL7
	move.w	#XMAXVIEW-8,d0
SNL7:
	move.w	d0,XCross(a6)

	sub.w	d3,d1
	add.w	#4,d1
	bpl.s	SNL8
	clr.w	d1
SNL8:
	cmp.w	#YMAXVIEW-8,d1
	bcs.s	SNL9
	move.w	#YMAXVIEW-8,d1
SNL9:
	move.w	d1,YCross(a6)

SNLExit:
	movem.l	(sp)+,d0-d3/a0
	rts


; ****************************************************************************
; ****************************************************************************
;
; Lemming stuff
;
; ****************************************************************************
; ****************************************************************************
;

;
; CheckFinished, N=1 if all lemmings have left the level by any means
;
CheckFinished:
        lea     LemTab(a6),a0
        clr.w   d0
        move.b  LemsTotal(a6),d0
        subq.b  #1,d0
CFLoop:
	move.w	LLemAct(a0),d1
	or.w	LLemCnt(a0),d1
	lea	10(a0),a0
	tst.w	d1
	dbne	d0,CFLoop
	tst.w	d0
	rts

;
; InitLemming
;

InitLemming:
        lea     LemTab(a6),a0
        clr.w   d0
        move.b  LemsTotal(a6),d0  ; max number of lems
        subq.b  #1,d0
ILLoop:
        clr.w   (a0)+
 ; The lemms will fall from the middle of the gate
        move.w  GaSpX(a6),d1    ; Start gate X
        lsl.w   #2,d1
        addq.w  #4,d1
        move.w  d1,(a0)+        ; X
        move.w  GaSpY(a6),d1    ; Start gate Y
	lsl.w	#3,d1
        move.b  #$ff,(a0)+      ; number above counter = ff inhibit
        move.b  d1,(a0)+        ; Y
        move.w  d0,d1
        addq.w  #1,d1
        move.w  d1,(a0)+        ; spawning number, 1..x
        move.w  #1,(a0)+        ; orientation: right
        dbra    d0,ILLoop
        move.w  #-1,(a0)        ; end of tab
        rts

;
; DoLemming
;

DoLemming:
 clr.b   LemCurrent(a6)
 move.b  #$80,LemTarget(a6)
 lea     LemTab(a6),a5
 
 sub.b   #1,LemSpawn(a6)
 and.b   #1,Chain(a6)

DLLoop:
 move.w  LLemAct(a5),LemAct(a6)
 move.w  LLemX(a5),LemX(a6)
 clr.w   d0
 move.b  LLemY(a5),d0
 move.w  d0,LemY(a6)
 move.w  LLemCnt(a5),LemCnt(a6)
 move.b  LLemCnt2(a5),LemCnt2(a6)
 move.b  LLemDir(a5),d0
 ext.w   d0
 move.w  d0,LemDir(a6)

 tst.w   LemAct(a6)
 bmi     DLEnd     ; end of table
 bne.s   DLStart   ; process this lemming
 tst.w   LemCnt(a6)
 beq     DLNext    ; 0=out of level
 tst.b   Chain(a6) ; spawn no more lemmings when chain bombing
 beq.s   DLSpawn
 clr.w   LemAct(a6)
 clr.w   LemCnt(a6)
 addq.b  #1,LemsOff(a6)
 bra     DLNext

DLSpawn:
 tst.b   LemSpawn(a6)
 bne     DLNext
 sub.w   #1,LemCnt(a6) ; waiting
 bne     DLNext
 move.w  #1,LemAct(a6) ; spawn lemming as faller
 addq.b  #1,LemsOut(a6)

DLStart:
 cmp.w   #8*LMAXROWS,LemY(a6)
 bcc     DLOff
 
; check for bomb chain effect
 tst.b   Chain(a6)
 beq.s   DLNoChain
 bmi.s   DLNoChain
 tst.b   LLemTime(a5)
 bpl.s   DLNoChain
 cmp.b   #13,LemAct+1(a6) ; Bomber
 beq.s   DLNoChain
 st      Chain(a6)
 move.b  #24,LLemTime(a5)
DLNoChain:
; check for bomb command
 move.b  GiveCommand(a6),d0
 cmp.b   LemCurrent(a6),d0
 bne.s   DLNoBombCmd
 bsr     DLCmdFloat	; also check for float and climb
 bsr     DLCmdClimb
 tst.b   LLemTime(a5)
 bpl.s   DLNoBombCmd
 bsr     DLCmdBomb
 bne.s   DLNoBombCmd
; init bomb delay
 move.b  #24,LLemTime(a5)
DLNoBombCmd:
; decrease time and run Bomber
 move.b  LLemTime(a5),d0
 bmi.s   DLNoBomber
 subq.b  #1,d0
 move.b  d0,LLemTime(a5)
 bpl.s   DLNoBomber
 bra     DLBomb

DLNoBomber:
 lea	DLBase(pc),a0
 clr.w	d0
 move.b	LemAct+1(a6),d0
 subq.w	#1,d0
 lsl.w	#1,d0
 move.w	0(a0,d0.w),d0
 jmp	0(a0,d0.w)

DLBase:                                 ; LemAct:
	dc.w	(DLFaller-DLBase)	; 1
	dc.w	(DLWalker-DLBase)	; 2
	dc.w	(DLDigger-DLBase)	; 3
	dc.w	(DLFloater-DLBase)	; 4
	dc.w	(DLLander-DLBase)	; 5
	dc.w	(DLSplasher-DLBase)	; 6
	dc.w	(DLClimber-DLBase)	; 7
	dc.w	(DLMiner-DLBase)	; 8
	dc.w	(DLBuilder-DLBase)	; 9
	dc.w	(DLShrugger-DLBase)	; 10
	dc.w	(DLJumpInner-DLBase)	; 11
	dc.w	(DLBlocker-DLBase)	; 12
	dc.w	(DLBomber-DLBase)	; 13
	dc.w	(DLBasher-DLBase)	; 14


DLFall:
 move.b  #1,LemAct+1(a6)
 move.w  #8,LemCnt(a6)
 clr.b   LemCnt2(a6)   ; count falling steps
 bra     DLNext
DLFaller:
 btst.w  #9,LemAct(a6)
 beq.s   DLFa1
 cmp.b   #5,LemCnt2(a6) ; no floating for short distances
 bcc     DLFloat
DLFa1:
 move.b  GiveCommand(a6),d0
;cmp.b   LemCurrent(a6),d0
;bne     DLFa2
; bsr     DLCmdFloat
DLFa2:
 move.w  LemCnt(a6),d0
 add.b   #1,d0
 and.b   #3,d0
 add.b   #8,d0
 move.w  d0,LemCnt(a6)
 move.w  LemX(a6),d0
 add.w   #1,d0
 move.w  LemY(a6),d1
 add.b   #16,d1
 bsr     GetAttribAtXY
 cmp.b   #5,d2   ; killing
 beq     DLSplash
 bsr     TestDepth
 tst.b   d7
 beq.s   DLFASpl
 add.w   d7,LemY(a6)
 addq.b  #1,LemCnt2(a6)
 bra     DLNext
DLFASpl:
 cmp.b   #21,LemCnt2(a6)
 bcc     DLSplash
;bra.s   DLWalk



DLWalk:
 move.b  #2,LemAct+1(a6)
 clr.w   d0
 tst.w   LemDir(a6)
 bpl.s   DLWLI
 or.b    #4,d0
DLWLI:
 move.w  d0,LemCnt(a6)
 clr.b   LemCnt2(a6)
 bra     DLNext
DLWalker:
 ; test if walker is at exit gate
 move.w	LemX(a6),d0
 move.w	LemY(a6),d1
 add.w  #4,d1
 bsr	GetAttribAtXY
 cmp.b	#2,d2
 beq	DLJumpIn

; btst.w  #8,LemAct(a6)
; beq     DLWLNCl
; bsr     DLClimbTest
; bne     DLClimb
;DLWLNCl:
 tst.b   LemCnt2(a6) ; buffer for block command
 bne.s   DLWLBl
 move.b  GiveCommand(a6),d0
 cmp.b   LemCurrent(a6),d0
 bne.s   DLWLCount
; bsr     DLCmdFloat
; bsr     DLCmdClimb
 bsr     DLCmdDig
 beq     DLDig
 bsr     DLCmdMine
 beq     DLMine
 bsr     DLCmdBash
 beq     DLBash
 bsr     DLCmdBuild
 beq     DLBuild
; special case for Blocker, Lemming must be tile-aligned
; set LemCnt2 to remember if not
 bsr     DLCmdBlock
 bne.s   DLWLCount
 st      LemCnt2(a6)
DLWLBl:
 tst.b   LemCnt2(a6)
 beq.s   DLWLCount
 move.w  LemX(a6),d0
 and.b   #3,d0
 beq     DLBlock

DLWLCount:
 move.w  LemCnt(a6),d0
 add.b   #1,d0
 and.b   #3,d0
 tst.w   LemDir(a6)
 bpl.s   DLWL
 or.b    #4,d0
DLWL:
 move.w  d0,LemCnt(a6)
 move.w  LemX(a6),d0
 add.w   #1,d0
 add.w   LemDir(a6),d0
 move.w  LemY(a6),d1
 add.w   #7,d1
 bsr     GetAttribAtXY
 cmp.b   #4,d2   ; blocking
 beq.s   DLWRev
 cmp.b   #5,d2   ; killing
 beq     DLSplash
 add.w   #8,d1
 bsr     GetAttribAtXY
 cmp.b   #5,d2   ; killing
 beq     DLSplash
 bsr     TestHeight1
 tst.b   d7
 bmi.s   DLWLClimb
 beq.s   DLW1
 sub.w   d7,LemY(a6)
 move.w  LemDir(a6),d6
 add.w   d6,LemX(a6)
 bra     DLNext
DLW1:
 move.w  LemX(a6),d0
 add.w   #1,d0
 add.w   LemDir(a6),d0
 move.w  LemY(a6),d1
 add.b   #16,d1
 bsr     TestDepth
 move.w  LemDir(a6),d6
 add.w   d6,LemX(a6)
 tst.b   d7
 bne.s   DLWDown
 bra     DLNext
DLWDown:
 cmp.b   #3,d7
 bcc     DLFall
 add.w   d7,LemY(a6)
 bra     DLNext
DLWRev:
 neg.w   LemDir(a6)
 move.w  LemDir(a6),d6
 add.w   d6,LemX(a6)
 eor.w   #4,LemCnt(a6)
 bra     DLNext
DLWLClimb:
 btst.w  #8,LemAct(a6)
 beq     DLWRev
 bra     DLClimb




DLDig:
 move.b  #3,LemAct+1(a6)
 move.w  #12,LemCnt(a6)
; if there are obstacles at the feet
 move.w  LemX(a6),d0
 move.w  LemY(a6),d1
 add.w   #15,d1
 bsr     PixClear4
; bsr     PixClear
; add.w   #1,d0
; bsr     PixClear
; add.w   #1,d0
; bsr     PixClear
; add.w   #1,d0
; bsr     PixClear
 bra     DLNext
DLDigger:
 move.b  GiveCommand(a6),d0
 cmp.b   LemCurrent(a6),d0
 bne.s   DLDig1
 bsr     DLCmdMine
 beq     DLMine
 bsr     DLCmdBash
 beq     DLBash
DLDig1:
 move.w  LemCnt(a6),d0
 add.b   #1,d0
 and.b   #7,d0
 add.b   #12,d0
 move.w  d0,LemCnt(a6)
 move.w  LemX(a6),d0
 add.w   #1,d0
 move.w  LemY(a6),d1
 add.b   #16,d1
 bsr     TestDepth
 cmp.w   #3,d7   ; two empty lines do not confuse the digger
 bcc     DLFall
 move.w  LemCnt(a6),d2
 and.w   #1,d2   ; dig speed, one line at every 2nd tick
 bne     DLNext
 move.w  LemX(a6),d0
 move.w  LemY(a6),d1
 add.w   #16,d1
 bsr     PixClear4
; bsr     PixClear
; add.w   #1,d0
; bsr     PixClear
; add.w   #1,d0
; bsr     PixClear
; add.w   #1,d0
; bsr     PixClear
 add.w   #1,LemY(a6)
 bra     DLNext



DLFloat:
 move.b  #4,LemAct+1(a6)
 move.w  #24,LemCnt(a6)
 bra     DLNext
DLFloater:
 move.w  LemCnt(a6),d0
 cmp.b   #28,d0   ; 24..27: open chute, 28..32 float
 bcc.s   DLFL1
 ; open chute
 addq.w  #1,LemCnt(a6)
 move.w  LemX(a6),d0
 add.w   #1,d0
 move.w  LemY(a6),d1
 add.b   #16,d1
 bsr     GetAttribAtXY
 cmp.b   #5,d2   ; killing
 beq.s   DLSplash     ; *
 bsr     TestDepth
 tst.b   d7
 beq.s   DLLand
 add.w   d7,LemY(a6)
 bra     DLNext
DLFL1:
 ; float
 move.w  LemCnt(a6),d0
 addq.w  #1,d0
 and.w   #3,d0
 add.w   #28,d0
 move.w  d0,LemCnt(a6)
 move.w  LemX(a6),d0
 add.w   #1,d0
 move.w  LemY(a6),d1
 add.b   #16,d1
 bsr     GetAttribAtXY
 cmp.b   #5,d2   ; killing
 beq.s   DLSplash
 bsr     TestDepth
 tst.b   d7
 beq.s   DLFLSpl
 addq.w  #1,LemY(a6)
 bra     DLNext
DLFLSpl:
 cmp.b   #21,LemCnt2(a6)
 bcc.s   DLSplash
;bra     DLLand



DLLand:
 move.b  #5,LemAct+1(a6)
 move.w  #27,LemCnt(a6)
 bra     DLNext
DLLander:
 move.w  LemCnt(a6),d0
 ; close chute
 subq.w  #1,d0
 cmp.w   #23,d0
 beq     DLWalk
 move.w  d0,LemCnt(a6)
 bra     DLNext



DLSplash:
 move.b  #6,LemAct+1(a6)
 move.w  #32,LemCnt(a6)
 bra     DLNext
DLSplasher:
 move.w  LemCnt(a6),d0
 addq.w  #1,d0
 cmp.w   #40,d0
 beq     DLOff 
 move.w  d0,LemCnt(a6)
 bra     DLNext



;DLClimbTest:
; move.w  LemX(a6),d0
; sub.w   #1,d0          ; for left dir
; tst.w   LemDir(a6)
; bmi     DLCLT1
; add.w   #4,d0
;DLCLT1:
; move.w  LemY(a6),d1
; add.b   #15,d1
; bsr     TestHeight
; tst.b   d7
; bmi     DLClimbYes
;DLClimbNo:
; cmp.b   d0,d0   ; Z=1
;DLClimbYes:
; ; Z=0 instead (d7 is negative)
; rts
 
DLClimb:
 subq.w  #2,LemX(a6)
 move.b  #7,LemAct+1(a6)
 move.w  #40,LemCnt(a6)   ; right ani
 tst.w   LemDir(a6)
 bpl     DLNext
 add.w   #8,LemCnt(a6)
 addq.w  #3,LemX(a6)
 bra     DLNext
DLClimber:
 move.b  GiveCommand(a6),d0
; cmp.b   LemCurrent(a6),d0
; bne.s   DLCLAni
;; bsr     DLCmdFloat
DLCLAni:
; animation
 move.w  LemCnt(a6),d0
 add.b   #1,d0
 and.b   #7,d0
 tst.w   LemDir(a6)
 bpl.s   DLCLR
 add.b   #8,d0
DLCLR:
 add.b   #40,d0
 move.w  d0,LemCnt(a6)
; test for next wall pixel
 move.w  LemX(a6),d0
 sub.w   #1,d0          ; for left dir
 tst.w   LemDir(a6)
 bmi.s   DLCL1
 add.w   #5,d0
DLCL1:
 move.w  LemY(a6),d1
 add.w   #11,d1
 bsr     PixTest
 beq.s   DLCLWalk       ; no wall, walk
; test for ledge
 subq.w  #3,d1
 sub.w   LemDir(a6),d0
 bsr     PixTest
 bne.s   DLCLFall       ; projection
; climb
; move.w  LemCnt(a6),d0
; and.w   #1,d0
; bne     DLNext
 sub.w   #1,LemY(a6)
 bra     DLNext
DLCLWalk:
 sub.w   #3,LemY(a6)
 move.w  LemDir(a6),d0
 asl.w   #1,d0
 add.w   d0,LemX(a6)
 bra     DLWalk
DLCLFall:
 neg.w   LemDir(a6)
 bra     DLFall



DLMine:
 move.b  #8,LemAct+1(a6)
; if there are obstacles at the feet
 move.w  LemX(a6),d0
 move.w  LemY(a6),d1
 add.w   #14,d1
 add.w   #1,d0
 add.w   LemDir(a6),d0
 bsr     PixClear
 add.w   #1,d0
 bsr     PixClear
 add.w   #1,d1
 bsr     PixClear
 sub.w   #1,d0
 bsr     PixClear
 move.w  #56,LemCnt(a6)
 tst.w   LemDir(a6)
 bpl     DLNext
 add.w   #8,LemCnt(a6)
 bra     DLNext
DLMiner:
 move.b  GiveCommand(a6),d0
 cmp.b   LemCurrent(a6),d0
 bne.s   DLM1
 bsr     DLCmdDig
 beq     DLDig
 bsr     DLCmdBash
 beq     DLBash
DLM1:
 move.w  LemCnt(a6),d0
 add.b   #1,d0
 and.b   #7,d0
 add.b   #56,d0
 tst.w   LemDir(a6)
 bpl.s   DLM2
 add.w   #8,d0
DLM2:
 move.w  d0,LemCnt(a6)
 and.w   #7,d0   ; mine at specific animation step
 cmp.w   #3,d0
 bne     DLNext
 tst.w   LemDir(a6)
 bmi.s   DLMLeft
 move.w  LemX(a6),d0
 add.w   #3,d0
 move.w  LemY(a6),d1
 add.b   #16,d1
 bsr     TestDepth
 cmp.w   #2,d7   ; one empty line does not confuse the miner
 bcc     DLFall
 move.w  LemCnt(a6),d2
; mine these pixels
;    x+2 -v
; y+16 -> 11223344
;           776655
;             88
 move.w  LemX(a6),d0
 move.w  LemY(a6),d1
 add.w   #16,d1
 add.w   #2,d0
 bsr     PixClear4
 add.w   #1,d1
 add.w   #1,d0
 bsr     PixClear
 add.w   #1,d0
 bsr     PixClear
 add.w   #1,d0
 bsr     PixClear
 sub.w   #1,d0
 add.w   #1,d1
 bsr     PixClear
 add.w   #2,LemY(a6)
 add.w   #1,LemX(a6)
 bra     DLNext
DLMLeft:
 move.w  LemX(a6),d0
 subq.w  #1,d0
 move.w  LemY(a6),d1
 add.b   #16,d1
 bsr     TestDepth
 cmp.w   #2,d7   ; one empty line does not confuse the miner
 bcc     DLFall
 move.w  LemCnt(a6),d2
; mine these pixels
;    x-2 -v
; y+16 -> 11223344
;         776655
;           88
 move.w  LemX(a6),d0
 move.w  LemY(a6),d1
 add.w   #16,d1
 sub.w   #2,d0
 bsr     PixClear4
 add.w   #1,d1
 bsr     PixClear
 add.w   #1,d0
 bsr     PixClear
 add.w   #1,d0
 bsr     PixClear
 sub.w   #1,d0
 add.w   #1,d1
 bsr     PixClear
 add.w   #2,LemY(a6)
 sub.w   #1,LemX(a6)
 bra     DLNext



DLBuild:
 move.b  #16,LemCnt2(a6)   ; number of steps
 move.b  #9,LemAct+1(a6)
 move.w  #72,LemCnt(a6)
 tst.w   LemDir(a6)
 bpl     DLNext
 addq.w  #8,LemCnt(a6)
 bra     DLNext
DLBuilder:
 move.w  LemCnt(a6),d0
 addq.b  #1,d0
 and.b   #7,d0
 add.b   #72,d0
 tst.w   LemDir(a6)
 bpl.s   DLBld1
 add.w   #8,d0
DLBld1:
 move.w  d0,LemCnt(a6)
 and.w   #7,d0
;cmp.w   #0,d0 ; obsolete
 tst.w   d0
 bne.s   DLBld2
; test if dir must be reverted
 move.w  LemX(a6),d0
 add.w   #1,d0
 move.w  LemY(a6),d1
 add.w   #14,d1
 bsr     PixTest
 bne.s   DLBldSR
 add.w   LemDir(a6),d0
 addq.w  #1,d1
 bsr     PixTest
 beq     DLNext
; revert
 move.w  LemDir(a6),d0
 add.w   d0,LemX(a6)
 neg.w   LemDir(a6)
 bra     DLNext
; shrug and revert
DLBldSR:
 neg.w   LemDir(a6)
 bra     DLShrug
DLBld2:
 cmp.w   #4,d0   ; build at specific animation step
 bne     DLNext
 move.w  LemX(a6),d0
 tst.w   LemDir(a6)
 bmi.s   DLBldLeft
DLBldRight:
 add.w   #2,d0
DLBldLeft:
 lsl.w   #1,d0
 btst.b  #0,LemCnt2(a6) ; use single pixels to build step
 beq.s   DLBld3
 add.w   LemDir(a6),d0
 move.w  LemDir(a6),d1
 add.w   d1,LemX(a6) ; X is adjusted every 2nd pixel (= every dpixel)
DLBld3:
 move.w  LemY(a6),d1
 add.w   #15,d1   ; to Lemming's feet
 bsr     PixSetS
 add.w   #1,d0
 bsr     PixSetS
 sub.w   #1,LemY(a6)
 sub.b   #1,LemCnt2(a6)
 beq.s   DLShrug
 bra     DLNext



DLShrug:
 move.b  #10,LemAct+1(a6)
 move.w  #88,LemCnt(a6)
 move.b  #1,LemCnt2(a6)
 bra     DLNext
DLShrugger:
 move.b  GiveCommand(a6),d0
 cmp.b   LemCurrent(a6),d0
 bne.s   DLS0
 bsr     DLCmdBuild
 beq     DLBuild
DLS0:
 move.w  LemCnt(a6),d0
 tst.b   LemCnt2(a6)
 beq.s   DLS1
; raise shoulders
 addq.w  #1,d0
 cmp.w   #91,d0
 bne.s   DLS2
 clr.b   LemCnt2(a6)
 bra     DLS2
DLS1:
; lower shoulders
 subq.w  #1,d0
 cmp.w   #87,d0
 beq     DLWalk
DLS2:
 move.w  d0,LemCnt(a6)
 bra     DLNext



DLJumpIn:
 move.b  #11,LemAct+1(a6)
 move.w  #20,LemCnt(a6)
 addq.b  #1,LemsIn(a6)
 st      LLemTime(a5)
 bra     DLNext
DLJumpInner:
 move.w  LemCnt(a6),d0
 add.b   #1,d0
 cmp.b   #24,d0
 beq     DLOff
 move.w  d0,LemCnt(a6)
 bra     DLNext


 
DLBlock:
 move.b  #12,LemAct+1(a6)
 move.w  #92,LemCnt(a6)
 clr.b   LemCnt2(a6)
; mark one tile as blocking
 move.w  LemX(a6),d0
 move.w  LemY(a6),d1
 add.w   #7,d1
 move.b  #4,d2   ; blocking
 bsr     SetAttribAtXY
 bra     DLNext
DLBlocker:
 move.w  LemCnt(a6),d0
 tst.b   LemCnt2(a6)
 bne.s   DLBlAni1
 addq.w  #1,d0
 cmp.w   #100,d0
 bne.s   DLBlAniEnd
 not.b   LemCnt2(a6)
 move.w  #96,d0
 bra.s   DLBlAniEnd
DLBlAni1:
 sub.w   #1,d0
 cmp.w   #91,d0
 bne.s   DLBlAniEnd
 not.b   LemCnt2(a6)
 move.b  #95,d0
DLBlAniEnd:
 move.w  d0,LemCnt(a6)
; test if Blocker looses ground
 move.w  LemX(a6),d0
 add.w   #1,d0
 add.w   LemDir(a6),d0
 move.w  LemY(a6),d1
 add.b   #16,d1
 bsr     TestDepth
 cmp.b   #3,d7
 beq     DLFall
 add.w   d7,LemY(a6)
 bra     DLNext


DLBomb:
 move.w	#100,LemCnt(a6)
; Faller(1), Floater(4) and Climber(7) explode without animation
 cmp.b	#1,LemAct+1(a6)
 beq.s  DLBoNoAni
 cmp.b	#4,LemAct+1(a6)
 beq.s  DLBoNoAni
 cmp.b	#7,LemAct+1(a6)
 bne.s  DLBo1

DLBoNoAni:
 move.w	#108,LemCnt(a6)	; indicates no ani
DLBo1:
 move.b #13,LemAct+1(a6)
 bra	DLNext
DLBomber:
 cmp.w	#108,LemCnt(a6) ; do the actual bomb effect
 beq.s  DLBoBomb
 addq.w	#1,LemCnt(a6)
 cmp.w	#116,LemCnt(a6)
 beq	DLOff
 bra	DLNext
DLBoBomb:
 addq.w	#1,LemCnt(a6)
; erase those pixels: l=occupied by lemming
;0            ****    
;1          ********  
;2        ************
;3        ************  
;4      ****************
;5      ****************  
;6      ****llllllll****  
;7    ******llllllll******  
;8    ******llllllll******    
;9    ******llllllll******    
;a    ******llllllll******    
;b    ******llllllll******  
;c    ******llllllll******   
;d      ****llllllll****  
;e      ****************  
;f      ****************
;g        ************
;h        ************
;i          ********  
;j            ****    

;0
 move.w	LemX(a6),d0
 addq.w	#1,d0
 move.w	LemY(a6),d1
 addq.w #2,d1
 bsr	PixClear
 addq.w	#1,d0
 bsr	PixClear
;1
 subq.w	#2,d0
 addq.w	#1,d1
 bsr	PixClear4
;2
 addq.w	#1,d1
 subq.w	#1,d0
 bsr	PixClear4
 addq.w	#2,d0
 bsr	PixClear4
;3
 addq.w	#1,d1
 bsr	PixClear4
 subq.w	#2,d0
 bsr	PixClear4
;4
 addq.w	#1,d1
 subq.w	#1,d0
 bsr	PixClear8
;5
 addq.w	#1,d1
 bsr	PixClear8
;6
 addq.w	#1,d1
 bsr	PixClear8
;7
 addq.w	#1,d1
 subq.w	#1,d0
 bsr	PixClear4
 addq.w	#2,d0
 bsr	PixClear8
;8
 addq.w	#1,d1
 bsr	PixClear8
 subq.w	#2,d0
 bsr	PixClear4
;9
 addq.w	#1,d1
 bsr	PixClear4
 addq.w	#2,d0
 bsr	PixClear8
;a
 addq.w	#1,d1
 bsr	PixClear8
 subq.w	#2,d0
 bsr	PixClear4
;b
 addq.w	#1,d1
 bsr	PixClear4
 addq.w	#2,d0
 bsr	PixClear8
;c
 addq.w	#1,d1
 bsr	PixClear8
 subq.w	#2,d0
 bsr	PixClear4
;d
 addq.w	#1,d1
 addq.w	#1,d0
 bsr	PixClear8
;e
 addq.w	#1,d1
 bsr	PixClear8
;f
 addq.w	#1,d1
 bsr	PixClear8
;g
 addq.w	#1,d1
 addq.w	#1,d0
 bsr	PixClear4
 addq.w	#2,d0
 bsr	PixClear4
;h
 addq.w	#1,d1
 bsr	PixClear4
 subq.w	#2,d0
 bsr	PixClear4
;i
 addq.w	#1,d1
 addq.w	#1,d0
 bsr	PixClear4
;j
 addq.w	#1,d1
 addq.w	#1,d0
 bsr	PixClear
 addq.w	#1,d0
 bsr	PixClear
 bra	DLNext 


DLBash:
 move.w	#14,LemAct(a6)
 move.w	#116,LemCnt(a6)
 tst.w	LemDir(a6)
 bpl	DLNext
 add.w	#8,LemCnt(a6)
 bra	DLNext
DLBasher:
; check for commands
 move.b  GiveCommand(a6),d0
 cmp.b   LemCurrent(a6),d0
 bne.s   DLBaNoCmd
 bsr     DLCmdDig
 beq     DLDig
 bsr     DLCmdMine
 beq     DLMine
DLBaNoCmd:
; animate
 move.w  LemCnt(a6),d0
 add.b   #1,d0
 cmp.b   #116+8,d0
 beq.s   DLBaAniBack
 cmp.b   #124+8,d0
 bne.s   DLBaAniDo
DLBaAniBack:
 subq.b  #8,d0
DLBaAniDo:
 move.w  d0,LemCnt(a6)
; do bashing
 and.b   #7,d0
 cmp.b   #7,d0
 beq.s   DLBa1
 cmp.b   #0,d0
 beq.s   DLBa2
 cmp.b   #1,d0
 beq.s   DLBa3
 cmp.b   #2,d0
 beq.s   DLBa4
 cmp.b   #3,d0
 beq     DLBa5  ; *
 bra     DLNext
DLBa1:
 move.w  LemX(a6),d0
 move.w  LemY(a6),d1
 addq.w  #8,d1
 bsr     PixClear4
 add.w   LemDir(a6),d0
 addq.w  #1,d1
 bsr     PixClear4
 bra     DLNext
DLBa2:
 move.w  LemX(a6),d0
 add.w   LemDir(a6),d0
 add.w   LemDir(a6),d0
 move.w  LemY(a6),d1
 add.w   #10,d1
 bsr     PixClear4
 addq.w  #1,d1
 bsr     PixClear4
 bra     DLNext
DLBa3:
 move.w  LemX(a6),d0
 add.w   LemDir(a6),d0
 add.w   LemDir(a6),d0
 move.w  LemY(a6),d1
 add.w   #12,d1
 bsr     PixClear4
 addq.w  #1,d1
 bsr     PixClear4
 bra     DLNext
DLBa4:
 move.w  LemX(a6),d0
 add.w   LemDir(a6),d0
 move.w  LemY(a6),d1
 add.w   #14,d1
 bsr     PixClear4
 move.w  LemX(a6),d0
 addq.w  #1,d1
 bsr     PixClear4
 bra     DLNext
DLBa5:
 move.w  LemX(a6),d0
 subq.w  #1,d0
 tst.w   LemDir(a6)
 bmi.s   DLBaLeft
 addq.w  #5,d0
DLBaLeft:
 move.w  LemY(a6),d1
 add.w   #7,d1
 bsr     GetAttribAtXY
 cmp.b   #4,d2   ; blocking
 beq.s   DLBaRWalk
 add.w   #8,d1
 bsr     PixTest
 bne.s   DLBaDepth
 add.w   LemDir(a6),d0
 bsr     PixTest
 beq     DLWalk
DLBaDepth:
 add.w   #1,d1
 move.w  LemX(a6),d0
 add.w   #1,d0
 bsr     TestDepth
 tst.b   d7
 bne     DLWalk
 move.w  LemDir(a6),d0
 asl.w   #1,d0
 add.w   d0,LemX(a6)
 bra     DLNext
DLBaRWalk:
 neg.w   LemDir(a6)
 bra     DLWalk



DLOff:
 clr.w   LemAct(a6)
 clr.w   LemCnt(a6)
 subq.b  #1,LemsOut(a6)
 addq.b  #1,LemsOff(a6)
 bra     DLNext



; Climb is a buffered command
DLCmdClimb:
 cmp.b	#0,Command(a6)
 bne.s  DLCmdEnd
 btst.w	#8,LemAct(a6)
 bne.s  DLCmdEnd        ; is already a climber
 tst.b  CmdClimb(a6)
 beq.s  DLCmdEnd
 sub.b  #1,CmdClimb(a6)
 bset.w	#8,LemAct(a6)
 rts

; Float is a buffered command
DLCmdFloat:
 cmp.b	#4,Command(a6)
 bne.s  DLCmdEnd
 btst.w	#9,LemAct(a6)
 bne.s  DLCmdEnd        ; is already a floater
 tst.b  CmdFloat(a6)
 beq.s  DLCmdEnd
 sub.b  #1,CmdFloat(a6)
 bset.w	#9,LemAct(a6)
DLCmdEnd:
 rts

; regular commands
; usage: call the sub DLCmd<command>
; returns Z=1 if command is taken and decrements the command counter
; use beq DL<command> to execute the command afterwards
; returns Z=0 else
DLCmdBuild:
 cmp.b  #2,Command(a6)
 bne.s  DLCmdNo
 tst.b  CmdBuild(a6)
 beq.s  DLCmdNo
 sub.b  #1,CmdBuild(a6)
 bra.s  DLCmdYes

DLCmdMine:
 cmp.b  #3,Command(a6)
 bne.s  DLCmdNo
 tst.b  CmdMine(a6)
 beq.s  DLCmdNo
 sub.b  #1,CmdMine(a6)
 bra.s  DLCmdYes

DLCmdBomb:
 cmp.b  #1,Command(a6)
 bne.s  DLCmdNo
 tst.b  CmdBomb(a6)
 beq.s  DLCmdNo
 sub.b  #1,CmdBomb(a6)
 bra.s  DLCmdYes

DLCmdBlock:
 cmp.b  #5,Command(a6)
 bne.s  DLCmdNo
 tst.b  CmdStop(a6)
 beq.s  DLCmdNo
 sub.b  #1,CmdStop(a6)
 bra.s  DLCmdYes

DLCmdBash:
 cmp.b  #6,Command(a6)
 bne.s  DLCmdNo
 tst.b  CmdBash(a6)
 beq.s  DLCmdNo
 sub.b  #1,CmdBash(a6)
 bra.s  DLCmdYes

DLCmdDig:
 cmp.b  #7,Command(a6)
 bne.s  DLCmdNo
 tst.b  CmdDig(a6)
 beq.s  DLCmdNo
 sub.b  #1,CmdDig(a6)
 bra.s  DLCmdYes

; Z=0, cmd not taken
DLCmdNo:
 tst.b  LemsOut(a6)
 rts

; Z=1, cmd taken
DLCmdYes:
 cmp.b  d0,d0
 rts
 

 
DLNext:
 tst.w   LemAct(a6)
 beq.s   DLNoTarget
 move.w  LemX(a6),d0
 sub.w   XCrossTrue(a6),d0
 add.w   #3,d0
 cmp.w   #7,d0
 bcc.s   DLNoTarget
 move.w  LemY(a6),d0
 sub.w   YCrossTrue(a6),d0
 add.w   #14,d0
 cmp.w   #14,d0
 bcc.s   DLNoTarget
 move.b  LemCurrent(a6),LemTarget(a6)
DLNoTarget:
 move.w  LemAct(a6),0(a5)
 move.w  LemX(a6),2(a5)
 move.b  LemY+1(a6),5(a5)
 move.w  LemCnt(a6),6(a5)
 move.w  LemDir(a6),8(a5)
 move.b  LemCnt2(a6),8(a5)   ; this is correct!
 lea     10(a5),a5
 add.b   #1,LemCurrent(a6)
 bra     DLLoop
DLEnd:
 tst.b   LemSpawn(a6)
 bne.s   DLEnd1
 move.b  LemSpawnInit(a6),LemSpawn(a6)
DLEnd1:
 rts

; PixTest
; in : d0.w X   out: Z=0 occupied
;      d1.w Y        Z=1 empty
PixTest:
 cmp.w	#4*LMAXCOLS,d0
 bcc.s  PixTestEnd
 cmp.w	#8*LMAXROWS,d1
 bcc.s  PixTestEnd
 movem.l d0-d2/a0-a1,-(sp)
 bsr     GetAttribAtXY
 cmp.b   #1,d2   ; 1-empty
 beq.s   PTEmpty
 cmp.b   #2,d2   ; 1-empty(exit)
 beq.s   PTEmpty
 move.l  hlplane0(a6),a0
 lea    lplane1(a6),a1
;; move.l  hlplane1(a6),a1
 move.b  d0,d2
 and.b   #3,d2
 lsl.b   #1,d2
 mulu    #LMAXCOLS,d1
 lsr.w   #2,d0
 add.w   d1,d0
 move.b  0(a0,d0.w),d1
 or.b    0(a1,d0.w),d1
 lsl.b   d2,d1
 and.b   #$c0,d1
 movem.l (sp)+,d0-d2/a0-a1
 rts
PTEmpty:
 movem.l (sp)+,d0-d2/a0-a1
 cmp.w   d0,d0    ; set Z=1 (empty pixel)
 rts
PixTestEnd:
 cmp.w   d0,d0    ; set Z=1 (empty pixel)
 rts

; PixSetS (single)
; in : d0.w X in pixels(!)
;      d1.w Y
PixSetS:
 cmp.w	#8*LMAXCOLS,d0
 bcc.s  PixSetSEnd
 cmp.w	#8*LMAXROWS,d1
 bcc.s  PixSetSEnd
 movem.l d0-d3/a0-a1,-(sp)
 move.l  hlplane0(a6),a0
 lea    lplane1(a6),a1
;; move.l  hlplane1(a6),a1
;; lea     8*LMAXROWS*LMAXCOLS(a0),a1

 move.b  d0,d2
 and.b   #7,d2
 mulu    #LMAXCOLS,d1
 lsr.w   #3,d0
 add.w   d1,d0
 move.b  #$80,d3
 lsr.b   d2,d3
 or.b    d3,0(a0,d0.w)
 or.b    d3,0(a1,d0.w)
 movem.l (sp)+,d0-d3/a0-a1
PixSetSEnd:
 rts
 
; PixClear
; in : d0.w X
;      d1.w Y

PixClear:
 movem.l d0-d3/a0-a1,-(sp)
 bsr     GetAttribAtXY
 cmp.b   #1,d2
 beq.s   PixClearEnd
 cmp.b   #2,d2
 beq.s   PixClearEnd
 cmp.b   #5,d2
 beq.s   PixClearEnd
 move.l  hlplane0(a6),a0
 lea    lplane1(a6),a1
;; move.l  hlplane1(a6),a1
;; lea     8*LMAXROWS*LMAXCOLS(a0),a1

 move.b  d0,d2
 and.b   #3,d2
 lsl.b   #1,d2
 mulu    #LMAXCOLS,d1
 lsr.w   #2,d0
 add.w   d1,d0
 move.b  #$3f,d3
 ror.b   d2,d3
 and.b   d3,0(a0,d0.w)
 and.b   d3,0(a1,d0.w)
PixClearEnd:
 movem.l (sp)+,d0-d3/a0-a1
 rts

; PixClear4, clear 4 dpixels in a row
; in : d0.w X
;      d1.w Y

PixClear4:
 movem.l d0-d4/a0-a1,-(sp)
 move.l  hlplane0(a6),a0
 lea    lplane1(a6),a1
;; move.l  hlplane1(a6),a1
;; lea     8*LMAXROWS*LMAXCOLS(a0),a1

 clr.b   d4
 bsr     GetAttribAtXY  ; *
 cmp.b   #1,d2
 beq.s   PixC4Next
 cmp.b   #2,d2
 beq.s   PixC4Next
 cmp.b   #5,d2
 beq.s   PixC4Next
 moveq   #1,d4
PixC4Next:
 addq.w  #4,d0
 bsr.s   GetAttribAtXY
 cmp.b   #1,d2
 beq.s   PixC4Next2
 cmp.b   #2,d2
 beq.s   PixC4Next2
 cmp.b   #5,d2
 beq.s   PixC4Next2
 or.b    #2,d4
PixC4Next2:
 subq.w  #4,d0
 move.b  d0,d2
 and.b   #3,d2
 lsl.b   #1,d2
 mulu    #LMAXCOLS,d1
 lsr.w   #2,d0
 add.w   d1,d0
 move.b  #$ff,d3
 lsr.b   d2,d3
 not.b   d3

 ror.b   #1,d4
 bcc.s   PixC4Sec
 and.b   d3,0(a0,d0.w)
 and.b   d3,0(a1,d0.w)
PixC4Sec:
 ror.b   #1,d4
 bcc.s   PixC4End
 addq.w  #1,d0
 not.b   d3
 and.b   d3,0(a0,d0.w)
 and.b   d3,0(a1,d0.w)
PixC4End:
 movem.l (sp)+,d0-d4/a0-a1
 rts

PixClear8:
 bsr	PixClear4
 addq.w	#4,d0
 bsr	PixClear4
 subq.w	#4,d0
 rts

; GetAttribAtXY
; in : d0.w X in dpixels
;      d1.w Y in pixels
; out: d2.b attrib
GetAttribAtXY:
 cmp.w	#4*LMAXCOLS,d0
 bcc.s	GetAEnd
 cmp.w	#8*LMAXROWS,d1
 bcc.s	GetAEnd
 movem.l d0-d1/d3/a0,-(sp)
 lea	AttribLevel(a6),a0
 lsr.w	#3,d1
 lsr.w	#3,d0
 clr.b	d3
 roxl.b	#3,d3
 mulu	#LMAXCOLS/2,d1
 add.w	d1,d0
 move.b	0(a0,d0.w),d2
 lsr.b	d3,d2
 and.b	#$0f,d2
 movem.l (sp)+,d0-d1/d3/a0
 rts
GetAEnd:
 move.b #1,d2   ; empty
 rts

; SetAttribAtXY
; in : d0.w X in dpixels
;      d1.w Y in pixels
;      d2.b attrib
SetAttribAtXY:
 cmp.w	#4*LMAXCOLS,d0
 bcc.s  SetAEnd
 cmp.w	#8*LMAXROWS,d1
 bcc.s  SetAEnd
 movem.l d0-d1/d3-d4/a0,-(sp)
 lea     AttribLevel(a6),a0
 lsr.w	#3,d1
 lsr.w	#3,d0
 clr.b	d3
 roxl.b	#3,d3
 mulu	#LMAXCOLS/2,d1
 add.w	d1,d0
 lsl.b  d3,d2
 move.b #$f0,d4
 lsr.b	d3,d4
 and.b	d4,0(a0,d0.w)
 or.b	d2,0(a0,d0.w)
 movem.l (sp)+,d0-d1/d3-d4/a0
SetAEnd:
 rts

; TestDepth
; in : do.w X   out: d7 Depth
;      d1.w Y
TestDepth:
 clr.w   d7
 bsr     PixTest
 bne.s   TDEnd
 add.w   #1,d0
 bsr     PixTest
 bne.s   TDEnd
 add.b   #1,d7
 add.b   #1,d1
 bsr     PixTest
 bne.s   TDEnd
 sub.w   #1,d0
 bsr     PixTest
 bne.s   TDEnd
 add.b   #1,d7
 add.b   #1,d1
 bsr     PixTest
 bne.s   TDEnd
 add.w   #1,d0
 bsr     PixTest
 bne.s   TDEnd
 add.b   #1,d7
TDEnd:
 rts

;; TestHeight
;; in : do.w X   out: d7 Height
;;      d1.w Y
;TestHeight:
; clr.w   d7
; bsr     PixTest
; bne     TH1
; add.w   #1,d0
; bsr     PixTest
; beq     THEnd
; bra     TH2
;TH1:
; add.w   #1,d0
;TH2:
; add.b   #1,d7
; sub.b   #1,d1
; bsr     PixTest
; bne     TH3
; sub.w   #1,d0
; bsr     PixTest
; beq     THEnd
; bra     TH4
;TH3:
; sub.w   #1,d0
;TH4:
; add.b   #1,d7
; sub.b   #1,d1
; bsr     PixTest
; bne     TH5
; add.w   #1,d0
; bsr     PixTest
; beq     THEnd
; bra     TH6
;TH5:
; add.w   #1,d0
;TH6:
; add.b   #1,d7
; sub.b   #1,d1
; bsr     PixTest
; bne     TH7
; sub.w   #1,d0
; bsr     PixTest
; beq     THEnd
;TH7:
; move.b  #$ff,d7
THEnd:
 rts

; TestHeight1, test only one column
; in : do.w X   out: d7 Height 0..4 or $ff(=too high)
;      d1.w Y
TestHeight1:
 clr.w   d7
 bsr     PixTest
 beq     THEnd
 add.b   #1,d7
 sub.b   #1,d1
 bsr     PixTest
 beq     THEnd
 add.b   #1,d7
 sub.b   #1,d1
 bsr     PixTest
 beq     THEnd
 add.b   #1,d7
 sub.b   #1,d1
 bsr     PixTest
 beq     THEnd
 add.b   #1,d7
 sub.b   #1,d1
 bsr     PixTest
 beq     THEnd
 move.b  #$ff,d7
 rts


; ****************************************************************************
; ****************************************************************************
;
; Screen Stuff
;
;
; ****************************************************************************
; ****************************************************************************

;
;  ShowScreen
;

ShowScreen:
        move.l  hlplane0(a6),a0
        lea     lplane1(a6),a2

        move.l  plane0(a6),a1           ; ~32 +
        move.l  plane1(a6),a3           ; ~24
        move.w  Yoff(a6),d0             ; ~24
        mulu.w  #LMAXCOLS,d0            ; ~82
        add.w   Xoff(a6),d0             ; ~24
        add.l   d0,a0                   ; ~10
        add.l   d0,a2                   ; ~10
        moveq   #10,d1
        moveq   #LMAXCOLS-20,d2

	IFND ti89
        add.l   d1,a1
        add.l   d1,a3
	ENDIF

        moveq   #YMAXVIEW-1,d0 ; height      ; ~8
f5_l1:  
        move.l  (a0)+,(a1)+             ; ~40
        move.l  (a0)+,(a1)+             ; ~40
        move.l  (a0)+,(a1)+             ; ~40
        move.l  (a0)+,(a1)+             ; ~40
        move.l  (a0)+,(a1)+             ; ~40    ; add 1 more
        add.l   d1,a1                   ; ~12
        add.l   d2,a0                   ; ~12

        move.l  (a2)+,(a3)+             ; ~40
        move.l  (a2)+,(a3)+             ; ~40
        move.l  (a2)+,(a3)+             ; ~40
        move.l  (a2)+,(a3)+             ; ~40
        move.l  (a2)+,(a3)+             ; ~40    ; add 1 more
        add.l   d1,a3                   ; ~12
        add.l   d2,a2                   ; ~12 ; 128*(40*10+4*12)=57344 cycles

        dbf     d0,f5_l1                ; ~18*111+26
;; ShowCross
        move.l  plane1(a6),a0
        btst.b  #0,cnt(a6)
        beq.s   f5_l2
        move.l  plane0(a6),a0
f5_l2:  move.w  YCross(a6),d0
        mulu    #30,d0
        add.l   d0,a0

        move.w  XCross(a6),d0
        move.w  d0,d1
        lsr.w   #3,d0
	IFND ti89
        add.w   #10,d0
	ENDIF
        add.l   d0,a0   ; position on the screen
        and.w   #7,d1

        ; d1 has shift value

        moveq   #7,d2
        lea     Cross(pc),a1
        tst.b   LemTarget(a6)
        bmi.s   f5_l4
        addq.l  #8,a1   ; Box
f5_l4:  clr.w   d0
        move.b  (a1)+,d0
        ror.w   d1,d0
        eor.b   d0,(a0)+
        ror.w   #8,d0
        eor.b   d0,(a0)+
        add.l   #28,a0
        dbf     d2,f5_l4
        rts

             
; *****************************************************************************
; SprDispInit
;
;

SprDispInit:
        clr.b   d7
        lea     SDLemTab(a6),a1
        lea     LemTab(a6),a0
SDILoop:
        tst.w   LLemAct(a0)
        bmi.s   SDIEnd
        beq.s   SDIOff
        move.w  LLemX(a0),d0
        lsr.w   #3,d0
        lsl.b   #1,d0
        sub.w   Xoff(a6),d0
        move.b  d0,SSDLemXc(a1) ; !
        cmp.b   #20,d0  ; changeable
        bcs.s   SDI1
        cmp.b   #-2,d0
        bcs.s   SDIOff
SDI1:
        move.w  LLemX(a0),d0
        and.b   #7,d0
        lsl.b   #1,d0
        move.b  d0,SSDLemXi(a1) ; !
        clr.w   d0
        move.b  LLemY(a0),d0
        sub.w   Yoff(a6),d0
        move.b  #1,SSDLemPut(a1)
        move.b  d0,SSDLemY(a1) ; !
        cmp.b   #YMAXVIEW-1,d0
        bcs.s   SDINext
        ;bpl.s   SDINext
        cmp.b   #-15,d0
        bcc.s   SDINext
SDIOff:
        clr.b   SSDLemPut(a1)
SDINext:
        move.b  LLemCnt+1(a0),SSDLemCnt(a1)
        lea     10(a0),a0
        addq.l  #5,a1
        addq.b  #1,d7
        bra     SDILoop
SDIEnd:
        move.b  #$ff,(a1) ; end of list
        rts

; ****************************************************************
; SprDisp
;
;

SprDisp:
        lea     SDLemTab(a6),a5
        lea     LemTab(a6),a4
SDMainLoop:
        tst.b   SSDLemPut(a5)
        bmi     SDEnd
        beq     SDNext
        move.l  plane1(a6),a1
        move.l  plane0(a6),a0
        lea     nums(pc),a3
	IFND ti89
        lea     10(a0),a0
        lea     10(a1),a1
	ENDIF
        ; number stuff
        clr.w   d0
        move.b  LLemTime(a4),d0
        bmi.s   SDCnt
        lsr.w   #2,d0
        addq.w  #1,d0                 ; skips the empty box
        lsl.w   #4,d0 ; /4*16         ; * number
        lea     0(a3,d0.w),a3         ; *
SDCnt:
        lea     WalkAnim(pc),a2
        clr.l   d0
        move.b  SSDLemCnt(a5),d0
        lsl.w   #5,d0
        add.l   d0,a2
        moveq   #16,d6 ; SDNumoflin
        move.l  #-1,d7 ; sdmask
        move.b  SSDLemY(a5),d0
SDTstUpper:
        cmp.b   #-15,d0
        bcs.s   SDTstLower
        add.b   #16,d0
        move.b  d0,d6
        clr.l   d1
        move.b  #16,d1
        sub.b   d0,d1
        add.l   d1,a2
        add.l   d1,a2
        add.l   d1,a3           ; number
        bra.s   SDTstLeft

SDTstLower:
        clr.w   d1
        move.b  d0,d1
        cmp.b   #YMAXVIEW-1-16,d0
        bls.s   SDCalcYAdr
        sub.b   #YMAXVIEW,d0
        neg.b   d0
        move.b  d0,d6
SDCalcYAdr:
        mulu    #30,d1
        add.l   d1,a0
        add.l   d1,a1

SDTstLeft:
        move.b  SSDLemXc(a5),d0
        cmp.b   #-2,d0
        bcs.s   SDTstRight
        clr.w   d7
        swap    d7
        bra     SDCalcXAdr

SDTstRight:
        cmp.b   #18,d0
        bcs.s   SDCalcXAdr
        clr.w   d7
SDCalcXAdr:
        move.b  SSDLemXc(a5),d0
        ext.w   d0
        lea     0(a0,d0.w),a0
        lea     0(a1,d0.w),a1
SDPut:
        move.b  SSDLemXi(a5),d2
        clr.w   d1
        subq.b  #1,d6 ; sdnumoflins
SDLoop:
        clr.l   d3
        move.b  (a2)+,d3
        or.b    (a3),d3        ; number
        ror.l   #8,d3
        lsr.l   d2,d3
        and.l   d7,d3
        or.l    d3,(a0)
        clr.l   d3
        move.b  (a2)+,d3
        or.b    (a3)+,d3        ; number
        ror.l   #8,d3
        lsr.l   d2,d3
        and.l   d7,d3
        or.l    d3,(a1)
        lea     30(a0),a0
        lea     30(a1),a1
        dbra    d6,SDLoop
SDNext:
        addq.l  #5,a5
	lea     10(a4),a4
        bra     SDMainLoop
SDEnd:
        rts

InitInfo:                  ; only draws the boxes,
        moveq   #7,d7
f7_l1:  move.w  d7,d2
        bsr.s   cquad
        dbf     d7,f7_l1
	clr.b	Command(a6)
	clr.b	d2
	bsr.s	pquad
        rts

	IFD ti89
qinfo:  dc.w    108*30+2
        dc.w    108*30+4
        dc.w    108*30+6
        dc.w    108*30+8
        dc.w    108*30+10
        dc.w    108*30+12
        dc.w    108*30+14
        dc.w    108*30+16
	ENDIF
	IFND ti89
qinfo:  dc.w    32*30
        dc.w    32*30+24*30
        dc.w    32*30+2*24*30
        dc.w    32*30+3*24*30
        dc.w    32*30+2
        dc.w    32*30+24*30+2
        dc.w    32*30+2*24*30+2
        dc.w    32*30+3*24*30+2
	ENDIF

pquad:
        move.l  plane1(a6),a1
        move.l  plane0(a6),a0
        lea     quadsdta(pc),a2

        and.w   #7,d2
        lsl.w   #1,d2
        move.w  qinfo(pc,d2.w),d1
        lea     0(a0,d1.w),a0
        lea     0(a1,d1.w),a1   ; gets the quad pos
        lsl.w   #5,d2
        lea     0(a2,d2.w),a2
        moveq   #15,d2
f8_l1:  move.w  (a2)+,(a0)+    ; puts two quads cleared
        move.w  (a2)+,(a1)+
        lea     28(a0),a0
        lea     28(a1),a1
        dbf     d2,f8_l1
        rts

cquad:
        move.l  plane1(a6),a0
        move.l  plane0(a6),a1
        lea     quadsdta(pc),a2

        and.w   #7,d2
        lsl.w   #1,d2
        move.w  qinfo(pc,d2.w),d1
        lea     0(a0,d1.w),a0
        lea     0(a1,d1.w),a1   ; gets the quad pos
        lsl.w   #5,d2
        lea     0(a2,d2.w),a2
        moveq   #15,d2
f9_l1:  clr.w   (a0)+           ; puts two quads cleared
        move.w  (a2)+,d1
        or.w    (a2)+,d1
        move.w  d1,(a1)+
        lea     28(a0),a0
        lea     28(a1),a1
        dbf     d2,f9_l1
        rts

ShowTargetName:
 clr.w   d7
 move.b  LemTarget(a6),d7
 bmi.s   STNNoTarget
 lsl.w   #1,d7   ; 12
 move.w  d7,d6   ; 8
 lsl.w   #2,d7   ; 14
 add.w   d6,d7   ; 8
 lea     LemTab(a6),a5
 move.w  0(a5,d7.w),d7
 btst.w  #8,d7
 beq.s   STN1
 btst.w  #9,d7
 beq.s   STN2
; 8 and 9 set -> athlete
 lea     NameTabAth(pc),a2
 bra.s   STNShow
STN1:
 btst.w  #9,d7
 beq.s   STNNoTarget
; 9 set -> Floater
 lea     NameTabFl(pc),a2
 bra.s   STNShow
STN2:
; 8 set -> Climber
 lea     NameTabCl(pc),a2
 bra.s   STNShow
STNNoTarget:
 lea     NameTab(pc),a2
 and.w   #15,d7 ; special case: only 8 entries
 lsl.b   #3,d7
 lea     0(a2,d7.w),a2
STNShow:
	IFD ti89
 move.w  #84,a1 ; y
 move.w  #0,a0  ; x
 	ENDIF
	IFND ti89
 move.w  #120,a1 ; y
 move.w  #0,a0  ; x
	ENDIF
 bsr     putstr
 rts


; --------------------------------
;
;  Change contrast
;
; --------------------------------

;IncContrast:
; moveq   #9,d0
; trap    #9
; jsr     (a0)
; bra MainLoop
;DecContrast:
; moveq   #10,d0
; trap    #9
; jsr     (a0)
; bra MainLoop

; --------------------------------
;
;  Interrupt handler - counting interrups
;
; --------------------------------

int_1:
        movem.l d0/a0,-(a7)                                  ;
        move.l  mvar+2(pc),a0    ; !@
        addq.w  #1,cnt(a0)
        move.w  cnt(a0),d0
        cmp.w   ntick(a0),d0
        bne.s   int_1_1
        ; tick
        move.b  #1,ticks(a0)
        add.w   #40,ntick(a0)
        ;add.w   #70,ntick(a0)
        addq.b  #1,ctick(a0)
        addq.w  #1,anit(a6)
int_1_1:
        cmp.b   #10,ctick(a0)
        ;cmp.b   #6,ctick(a0)
        bne.s   int_1_2
        clr.b   ctick(a0)
        subq.b  #1,time+1(a0)
        bpl.s   int_1_2
        move.b  #59,time+1(a0)
        subq.b  #1,time(a0)
        bpl.s   int_1_2
        move.b  #3,gstatus(a0)  ; time is up
int_1_2:
    IFD ti92 ; my own gray4lib
        move.w  nphase(a0),d0
        addq.w  #2,d0
        cmp.w   #6,d0
        bne.s   int_1_3
        clr.w   d0
int_1_3:
        move.w  table(a0,d0.w),($600010)
        move.w  d0,nphase(a0)
    ENDIF
        movem.l (a7)+,d0/a0
	rte

; --------------------------------
;
;  Initialize grayscale and handles
;
; --------------------------------

initgr4lib:
        movem.l d0-d7/a0-a5,-(sp)
;
; memory allocation
;
    IFND ti92
        move.l  #8*LMAXROWS*LMAXCOLS+STACK,-(sp)
        jsr     doorsos::HeapAlloc
        addq.l  #4,a7                      ; !@
        tst.w   d0
        beq     graylib_fail
        lea     mvar(pc),a1
        move.w  d0,(a1)         ; saves handle
        doorsos::DEREF d0,a6
        move.l  a6,2(a1)        ; saves to mvar, a6 -> Vars
        moveq   #31,d1
        move.l  a6,a0
initgrloop:
        clr.l   (a0)+           ; clears variables area
        dbf     d1,initgrloop
        lea     lplane0(a6),a0
        move.l  a0,hlplane0(a6)
    ENDIF
    IFD ti92
        move.l  #LPLANESIZE+3848,-(sp)
        jsr     tios::HeapAlloc
        addq.l  #4,a7                      ; !@
	tst.w	d0
        beq     graylib_fail
        move.l  mvar+2(pc),a6
        moveq   #31,d1
        move.l  a6,a0
initgrloop:
        clr.l   (a0)+           ; clears variables area
        dbf     d1,initgrloop
        move.w  d0,handle(a6)   ; only useful for ti92
        tios::DEREF d0,a0
        move.l  a0,hlplane0(a6)
    ENDIF
        

        ; important order if gray4lib is used
	; first modify the system int and the greyscale
	; our int is then the master of gs
	; otherwise gs would return to the system int
;        clr.w   cnt(a6)
;        clr.b   ctick(a6)
        move.w  #70,ntick(a6)
        move.w  #$0700,d0
	trap	#1
        move.l  $64,old_int_1(a6)
	bclr.b	#2,$600001
	move.l	#int_1,$64
	bset.b	#2,$600001
	trap	#1
    IFD ti92 ; uses built in gray4lib
        lea     LPLANESIZE+7(a0),a0
        move.l  a0,d0

        lsr.l   #3,d0
        move.w  d0,table(a6)
        lsl.l   #3,d0
        move.l  d0,plane0(a6)
        move.l  #LCD_MEM,d0
        lsr.l   #3,d0
        move.w  d0,table+2(a6)
        move.w  d0,table+4(a6)
	move.l	#LCD_MEM,plane1(a6)
        clr.w   nphase(a6)
    ENDIF
    IFND ti92
        jsr     gray4lib::on
        move.l  gray4lib::plane0,plane0(a6)
        move.l  gray4lib::plane1,plane1(a6)
    ENDIF
        bsr ClearScreen
        moveq   #1,d1   ; !@
graylib_fail:
        movem.l (sp)+,d0-d7/a0-a5
        rts


ClearScreen:
        movem.l d1/a0-a1,-(a7)
        move.w  #959,d1         ; !@
        move.l  plane0(a6),a0
        move.l  plane1(a6),a1
RepClr:
        clr.l   (a0)+
        clr.l   (a1)+
        dbf     d1,RepClr
        movem.l (a7)+,d1/a0-a1
        rts
 
; --------------------------------
;
;  Remove grayscale and handles
;
; --------------------------------

exitgr4lib:
	; first release gs, then the int
    IFND ti92
        jsr     gray4lib::off
        move.w  mvar(pc),-(sp)  ; !@
        jsr     doorsos::HeapFree
    ENDIF
    IFD ti92
        move.w  handle(a6),-(sp)
        jsr     tios::HeapFree
    ENDIF
        lea     2(a7),a7

        movem.l d0-d7/a0-a6,-(sp)
        move.w  #$0700,d0
	trap	#1
	bclr.b	#2,$600001
        move.l  old_int_1(a6),$64
	bset.b	#2,$600001
        trap    #1
    IFD ti92
        move.l  #LCD_MEM,d0
        lsr.l   #3,d0
        move.w  d0,($600010)
    ENDIF
        
        movem.l (sp)+,d0-d7/a0-a6
        rts

; ********************************************************
; Extracts the level from the tiles
; Initilizes all the variables related to the level
;
;

extractlvl:
        bsr     GetLibInfo
        ; a0 pointer to the packed level
        ; A1    "     "  "  packed tiles
        ; A3    "     "  "  attribute table

	move.l  a3,AttribPtr(a6)	; attributes are not packed
        move.w  d0,d2	; save index to level inside archive
	move.l	a0,a3	; need a0 for extracting

	; extract the tiles to a temporal area (lplane)
        move.l  a1,a0
        bsr     OpenArchive
        clr.w   d1
        lea     lplane1(a6),a0
        bsr     Extract
        ; normal tiles, move them temporarily to plane0
        lea     lplane1(a6),a0
	move.l  plane0(a6),a1
	move.w	#192*2-1,d0	; 192 normal tiles
f4_l00: move.l  (a0)+,(a1)+
        move.l  (a0)+,(a1)+
        dbf     d0,f4_l00
	; animated tiles have their own space
        lea     AnimTiles(a6),a1
        move.w  #64*2-1,d0      ; 64 animated tiles ; @#
f4_l01: move.l  (a0)+,(a1)+
        move.l  (a0)+,(a1)+
        dbf     d0,f4_l01

        ; extract level to temporal level data area (lplane)
	move.l	a3,a0
        bsr     OpenArchive
        lea     lplane1(a6),a0
        clr.w   d1
        bsr     Extract
        ; d2 contains the level in the extracted level data
        lea     lplane1(a6),a0
        mulu    #LMAXCOLS*LMAXROWS,d2 ; index
        add.l   d2,a0
        lea     TLevel(a6),a1   ; level destiation addr
        moveq   #124,d0         ; 1000
f4_l0:  move.l  (a0)+,(a1)+
        move.l  (a0)+,(a1)+
        dbf     d0,f4_l0
        
        move.l  plane0(a6),a0   ; Tiles
        move.l  hlplane0(a6),a1
        lea     lplane1(a6),a2
        lea     TLevel(a6),a3
        movea.l AttribPtr(a6),a4   ;attr
        lea     AttribLevel(a6),a5

        clr.w   d4      ; count Y (for GaSpY)
        moveq   #LMAXROWS-1,d2  ; height
f4_l1:  moveq   #LMAXCOLS-1,d0  ; width
	clr.w	d3	; count X (for GaSpX)
f4_l2:  clr.w   d1
        move.b  (a3)+,d1
        lsl.w   #4,d1   ; ptr to tile inside the tile list
        move.b  0(a0,d1.w),(a1)+
        move.b  1(a0,d1.w),(a2)+
        move.b  2(a0,d1.w),LMAXCOLS-1(a1)
        move.b  3(a0,d1.w),LMAXCOLS-1(a2)
        move.b  4(a0,d1.w),2*LMAXCOLS-1(a1)
        move.b  5(a0,d1.w),2*LMAXCOLS-1(a2)
        move.b  6(a0,d1.w),3*LMAXCOLS-1(a1)
        move.b  7(a0,d1.w),3*LMAXCOLS-1(a2)
        move.b  8(a0,d1.w),4*LMAXCOLS-1(a1)
        move.b  9(a0,d1.w),4*LMAXCOLS-1(a2)
        move.b 10(a0,d1.w),5*LMAXCOLS-1(a1)
        move.b 11(a0,d1.w),5*LMAXCOLS-1(a2)
        move.b 12(a0,d1.w),6*LMAXCOLS-1(a1)
        move.b 13(a0,d1.w),6*LMAXCOLS-1(a2)
        move.b 14(a0,d1.w),7*LMAXCOLS-1(a1)
        move.b 15(a0,d1.w),7*LMAXCOLS-1(a2)
	; attrib
	lsr.w	#5,d1
	bcc	f4_l201
	; odd tile number: lower nibble
	move.b  0(a4,d1.w),d5
	and.b	#$0f,d5
	bra.s	f4_l202
f4_l201:
	; even tile number: upper nibble
	move.b  0(a4,d1.w),d5
	lsr.b	#4,d5
f4_l202:
	cmp.b	#3,d5	; spawn
        bne.s   f4_l21
	move.w	d3,GaSpX(a6)
	move.w	d4,GaSpY(a6)
	moveq.b	#1,d5	; empty
f4_l21:	
	; set the attrib for every tile
	btst	#0,d3
	bne.s	f4_l22
	; even x-pos (comes first): lower nibble
	move.b	d5,(a5)
	bra.s	f4_l23
f4_l22:
	; odd x-pos: upper nibble
	lsl.b	#4,d5
	or.b	d5,(a5)+
f4_l23:
	addq.w	#1,d3
        dbf     d0,f4_l2
        add.l   #LMAXCOLS*7,a1
        add.l   #LMAXCOLS*7,a2
	addq.w	#1,d4
        dbf     d2,f4_l1

; now we use the level data to initilize the variables
        bsr     GetLibInfo
        ; a2 points to the specific-level data

; number of commands for this level

        move.b  LClimb(a2),CmdClimb(a6)
        move.b  LBomb(a2),CmdBomb(a6)
        move.b  LBuild(a2),CmdBuild(a6)
        move.b  LMine(a2),CmdMine(a6)
        move.b  LFloat(a2),CmdFloat(a6)
        move.b  LStop(a2),CmdStop(a6)
        move.b  LBash(a2),CmdBash(a6)
        move.b  LDig(a2),CmdDig(a6)

; count lemmings

        move.b  LLemTot(a2),LemsTotal(a6)
        clr.b   LemsOut(a6)         ; actually out in the level
        clr.b   LemsIn(a6)          ; exited through the gate
        clr.b   LemsOff(a6)         ; exited or fallen off the level, bombed, ...
        move.b  LLemSp(a2),LemSpawnInit(a6)
        move.b  LLemSp(a2),LemSpawn(a6)

; if   LemsOff = LemsTotal
; then there are no more lemmings left
; and success can be checked
; Gates

        move.w  #10,XCross(a6)
        move.w  #10,YCross(a6)

; Time left
        move.w  LTime(a2),time(a6)
	sf      Chain(a6)
; set Xoff to show start gate in the middle of the screen (if possible)
        move.w  GaSpX(a6),d0
	sub.w	#XMAXVIEW/16-2,d0   ; 2=<size of the gate(4)>/2
        bmi.s   f4_l3
	cmp.w	#LMAXCOLS-XMAXVIEW/8,d0
        bls.s   f4_l4
	; stick screen to right boundary
	move.w	#LMAXCOLS-XMAXVIEW/8,d0
        bra.s   f4_l4
f4_l3:
	; stick screen to left boundary
	clr.w	d0
f4_l4:
	and.w	#$fe,d0   ; Xoff is used in 2-byte steps
	move.w	d0,Xoff(a6)
        clr.w   Yoff(a6)
        clr.w   anit(a6)
        bsr     InitLemming
        rts


; *************************
;
; a0,a1 : pos
; a2    : ptr a una asciiz
;
; a0 : X
; a1 : Y

putstr: movem.l d0/a0-a2,-(a7)
        clr.l   d0
        move.w  a1,d0
        lsl.w   #5,d0
        sub.w   a1,d0
        sub.w   a1,d0
        add.w   a0,d0
        move.l  plane1(a6),a0
        add.l   d0,a0           ; mem de video lista
                     
f1_l1:  clr.w   d0
        move.b  (a2)+,d0
        beq.s   f1_l10
        lea     charset(pc),a1
        sub.b   #48,d0  ; adjusted !
        lsl.w   #3,d0
        add.l   d0,a1

        move.b  (a1)+,(a0)
        lea     30(a0),a0
        move.b  (a1)+,(a0)
        lea     30(a0),a0
        move.b  (a1)+,(a0)
        lea     30(a0),a0
        move.b  (a1)+,(a0)
        lea     30(a0),a0
        move.b  (a1)+,(a0)
        lea     30(a0),a0
        move.b  (a1)+,(a0)
        lea     30(a0),a0
        move.b  (a1)+,(a0)
        lea     30(a0),a0
        move.b  (a1)+,(a0)
        lea     -209(a0),a0
        bra     f1_l1
f1_l10:
        movem.l (a7)+,d0/a0-a2
        rts

; ***************************************
; Prints out the variables like as time, lemms out, lems left
;
;
putdec: ext.w   d0
        ext.l   d0      ; to clear the high word
        move.l  a2,a0
        divu    #10,d0
        lsl.l   #4,d0
        move.w  d0,d1 ; decs
        swap    d0    ; units
        lea     0(a3,d1.w),a1
        lea     0(a3,d0.w),a4
        moveq   #5,d1
f11_l1: clr.w   d0
        move.b  (a1)+,d0
        lsl.w   #5,d0
        move.b  (a4)+,d0
        move.w  d0,(a0)
        lea     30(a0),a0
        dbf     d1,f11_l1
	IFD ti89
        lea     2(a2),a2
	ENDIF
	IFND ti89
        lea     24*30(a2),a2
 	ENDIF
        rts       

; very different for 89 and 92, 2 large IFDs

	IFD ti89
showvar:
; prepare the menu with the amount of each command
        move.l  plane1(a6),a2
        add.l   #104*30+2,a2
        lea     nums+16(pc),a3
        move.b  CmdClimb(a6),d0
        bsr.s   putdec
        move.b  CmdBomb(a6),d0
        bsr.s   putdec
        move.b  CmdBuild(a6),d0
        bsr.s   putdec
        move.b  CmdMine(a6),d0
        bsr.s   putdec
        move.b  CmdFloat(a6),d0
        bsr.s   putdec
        move.b  CmdStop(a6),d0
        bsr.s   putdec
        move.b  CmdBash(a6),d0
        bsr.s   putdec
        move.b  CmdDig(a6),d0
        bsr.s   putdec

;; clear lines between level area and menu
	move.l	plane0(a6),a0
	move.l	plane1(a6),a1
	lea	30*YMAXVIEW(a0),a0
	lea	30*YMAXVIEW(a1),a1
	move.w	#12,d0
	sub.w	menupos(a6),d0
	clr.l	d1
	clr.l	d2
	clr.l	d3
	clr.l	d4
	clr.l	d5
showvar_cl:
	subq.w	#1,d0
	bmi	showvar_vars
	movem.l	d1-d5,(a0)
	movem.l	d1-d5,(a1)
	lea	30(a0),a0
	lea	30(a1),a1
	bra	showvar_cl

showvar_vars:
	; avoid flickering if the menu is active
	tst.w	menupos(a6)
	bne.s	showvar_menu

	bsr	ShowTargetName
        move.w  #7,a0
        move.w  #84,a1
        move.b  time(a6),d0
        lea     stime(pc),a2
        clr.w   d2
        bsr     putdec8a
        move.b  time+1(a6),d0
        addq.w  #3,a0
        bsr     putdec8aa
        addq.l  #3,a0
        move.b  LemsOut(a6),d0
        lea     lout(pc),a2
        moveq   #1,d2
        bsr     putdec8a
        addq.l  #3,a0
        move.b  LemsIn(a6),d0
        moveq   #1,d2
        lea     lin(pc),a2
        bsr     putdec8a

showvar_menu:
	; a0,a1 pointers to hidden menu
	; a2,a3 screen
	move.l	plane0(a6),a0
	move.l	plane1(a6),a1
	movea.l	a0,a2
	movea.l	a1,a3
	lea	30*104(a0),a0
	lea	30*104(a1),a1
	move.w	menupos(a6),d0	; 0...12
	addq.w	#7,d0		; 8...20 lines shown
	move.w	#99,d1		; above last line
	sub.w	d0,d1
	mulu	#30,d1
	lea	0(a2,d1.w),a2
	lea	0(a3,d1.w),a3
SMLoop:
	movem.l	(a0),d1-d5
	movem.l	d1-d5,(a2)
	movem.l	(a1),d1-d5
	movem.l	d1-d5,(a3)
	lea	30(a0),a0
	lea	30(a1),a1
	lea	30(a2),a2
	lea	30(a3),a3
	dbf	d0,SMLoop
	rts
	ENDIF

	IFND ti89
showvar:
; prepare the menu with the amount of each command
        move.l  plane1(a6),a2
        add.l   #26*30,a2
        lea     nums+16(pc),a3
        move.b  CmdClimb(a6),d0
        bsr.s   putdec
        move.b  CmdBomb(a6),d0
        bsr.s   putdec
        move.b  CmdBuild(a6),d0
        bsr.s   putdec
        move.b  CmdMine(a6),d0
        bsr.s   putdec
        move.l  plane1(a6),a2
        add.l   #26*30+2,a2
        move.b  CmdFloat(a6),d0
        bsr.s   putdec
        move.b  CmdStop(a6),d0
        bsr.s   putdec
        move.b  CmdBash(a6),d0
        bsr.s   putdec
        move.b  CmdDig(a6),d0
        bsr.s   putdec

	bsr	ShowTargetName
        move.w  #0,a0
        move.w  a0,a1
        move.b  time(a6),d0
        lea     stime(pc),a2
        clr.w   d2
        bsr     putdec8a
        move.b  time+1(a6),d0
        addq.w  #3,a0
        bsr     putdec8aa
        move.w  #0,a0
        addq.l  #8,a1
        move.b  LemsOut(a6),d0
        lea     lout(pc),a2
        moveq   #6,d2
        bsr     putdec8a
        addq.l  #8,a1
        move.w  #0,a0
        move.b  LemsIn(a6),d0
        moveq   #6,d2
        lea     lin(pc),a2
        bsr     putdec8a
        rts
	ENDIF


; ***********************
;
; updates the animated tiles
;
updateani:

; animated tiles are tiles > 192
;
        move.l  hlplane0(a6),a1 ; dest hlplane 0
        lea     lplane1(a6),a2   ; dest hlplane 1

        lea     TLevel(a6),a3
        lea     AnimTiles(a6),a0
        
        moveq   #LMAXROWS-1,d2  ; height
f6_l1:  moveq   #LMAXCOLS-1,d0  ; width
f6_l2:  clr.w   d1
        move.w  anit(a6),d3
        move.b  (a3)+,d1 ; tile number
        cmp.b   #192,d1
        bcs.s   f6_l6
        cmp.b   #203,d1
        bcc.s   f6_l3
        ; animated gate
        cmp.w   #4,d3
        bcs     f6_l3   ; skips   ; bcc f6_l6

f6_l6:  addq.l  #1,a1
        addq.l  #1,a2
        bra     f6_l4

f6_l3:  sub.b   #192,d1
        add.b   d1,d3
        and.w   #3,d3
        and.w   #$fffc,d1
        add.w   d1,d3
        lsl.w   #4,d3
        move.b  0(a0,d3.w),(a1)+
        move.b  1(a0,d3.w),(a2)+
        move.b  2(a0,d3.w),LMAXCOLS-1(a1)
        move.b  3(a0,d3.w),LMAXCOLS-1(a2)
        move.b  4(a0,d3.w),2*LMAXCOLS-1(a1)
        move.b  5(a0,d3.w),2*LMAXCOLS-1(a2)
        move.b  6(a0,d3.w),3*LMAXCOLS-1(a1)
        move.b  7(a0,d3.w),3*LMAXCOLS-1(a2)
        move.b  8(a0,d3.w),4*LMAXCOLS-1(a1)
        move.b  9(a0,d3.w),4*LMAXCOLS-1(a2)
        move.b 10(a0,d3.w),5*LMAXCOLS-1(a1)
        move.b 11(a0,d3.w),5*LMAXCOLS-1(a2)
        move.b 12(a0,d3.w),6*LMAXCOLS-1(a1)
        move.b 13(a0,d3.w),6*LMAXCOLS-1(a2)
        move.b 14(a0,d3.w),7*LMAXCOLS-1(a1)
        move.b 15(a0,d3.w),7*LMAXCOLS-1(a2)
f6_l4:  dbf     d0,f6_l2
        add.l   #LMAXCOLS*7,a1
        add.l   #LMAXCOLS*7,a2
        dbf     d2,f6_l1
        rts

; *******************
; returns key pressed (not when the key has been pressed)
;
;               92(+)   89
; KeyStat : 0 : hand	up
;           1 : left	left
;           2 : up	down
;           3 : right	right
;           4 : down	2nd
;           5 : clear	shift
;           6 : ESC	diamond
;           7 : Apps	clear
; KeyStat+1:x : F-keys  0: ESC

	IFD ti89
ScanKeys:
        move.l  #$600019,a0
        lea     2(a0),a1

        move.b  #%11111110,(a0)
        asr.l   #8,d1       ; recovery
        asr.l   #8,d1
        asr.l   #8,d1
        move.b  (a1),d0     ; Arrows
        move.b  #%10111111,(a0) ; ESC Key prep
        not.b   d0
        and.b   #%01111111,d0
        move.b  d0,KeyStat(a6)
; process ESC Key
        asr.l   #8,d1
        asr.l   #8,d1
        move.b  (a1),d0
        move.b  #%11111101,(a0) ; clear Key prep
        not.b   d0
        and.b   #%00000001,d0
        move.b  d0,KeyStat+1(a6)
; process clear Key
        move.b  (a1),d0
        not.b   d0
        and.b   #%01000000,d0	; clear
	add.b	d0,d0
        or.b    d0,KeyStat(a6)

	lea	cmdtrig(pc),a0
	move.b	(a0),d0
	move.b	KeyStat(a6),(a0)
	btst	#4,d0
	beq	SKExit
	bclr	#4,KeyStat(a6)
SKExit:
        rts
	ENDIF

	IFND ti89
ScanKeys:
        move.l  #$600018,a0
        lea     3(a0),a1

        move.w  #%1111111111111110,(a0)
        asr.l   #8,d1       ; recovery
        asr.l   #8,d1
        asr.l   #8,d1
        move.b  (a1),d0     ; Arrows
        move.w  #%1111111011111111,(a0) ; ESC Key prep
        not.b   d0
        lsr.b   #3,d0
        move.b  d0,KeyStat(a6)
; process ESC Key
        asr.l   #8,d1
        asr.l   #8,d1
        move.b  (a1),d0
        move.w  #%1111111101111111,(a0) ; clear/Apps Key prep
        not.b   d0
        and.b   #%01000000,d0
        or.b    d0,KeyStat(a6)
; process clear Key
        move.b  (a1),d0
        not.b   d0
	move.b	d0,d1
        and.b   #%00100000,d0	; clear
	and.b	#%01000000,d1	; Apps
	add.b	d1,d1
        or.b    d0,d1
        or.b    d1,KeyStat(a6)
; process the FX

        move.w  #%1111111111111101,d0
        move.w  d0,(a0)
        asr.l   #8,d1
        asr.l   #8,d1
        asr.l   #8,d1
        clr.b   d2
        moveq   #8,d3
        lea     Fx(pc),a2
f10_l1:
        asr.l   #8,d1
        asr.l   #8,d1
        move.b  (a1),d1
        rol.w   #1,d0
        move.w  d0,(a0)
        and.b   #16,d1
        bne     f10_l2
        or.b    (a2),d2
f10_l2: addq.l  #1,a2
        dbf     d3,f10_l1
        move.b  d2,KeyStat+1(a6)

	lea	cmdtrig(pc),a0
	move.b	(a0),d0
	move.b	KeyStat(a6),(a0)
	btst	#0,d0
	beq	SKExit
	bclr	#0,KeyStat(a6)
SKExit:
        rts
	ENDIF

; **************************************************************************
;
; Prelevel - screen
;
;

prescr:
        bsr     ClearScreen
        ; draws the minilvel 100x40 pixels

        move.l  plane1(a6),a0
        move.l  plane0(a6),a1
        move.l  hlplane0(a6),a2
        lea     lplane1(a6),a3
	IFD ti89
        lea     4(a0),a0
        lea     4(a1),a1
	ENDIF
	IFND ti89
        lea     9(a0),a0
        lea     9(a1),a1
	ENDIF

        moveq   #39,d0
f12_l1: moveq   #11,d1
f12_l2: moveq   #3,d5
        clr.b   d4
f12_l3: lsl.b   #2,d4
        move.b  (a2)+,d2
        move.b  d2,d3
        and.b   #$80,d2
        rol.b   #2,d2
        and.b   #$08,d3
        lsr.b   #3,d3
        or.b    d3,d2
        or.b    d2,d4
        dbra    d5,f12_l3
        move.b  d4,(a0)+
        moveq   #3,d5
        clr.b   d4
f12_l4: lsl.b   #2,d4
        move.b  (a3)+,d2
        move.b  d2,d3
        and.b   #$80,d2
        rol.b   #2,d2
        and.b   #$08,d3
        lsr.b   #3,d3
        or.b    d3,d2
        or.b    d2,d4
        dbra    d5,f12_l4
        move.b  d4,(a1)+

        dbra    d1,f12_l2
        lea     152(a2),a2
        lea     152(a3),a3
        lea     18(a0),a0
        lea     18(a1),a1
        dbra    d0,f12_l1

        bsr     GetLibInfo
        ; a2 points to the specific level data
        ; d0/a0/a1 destroyed
        move.l  a2,a4
        lea     LMsg(a2),a2       ; message
	IFD ti89
        move.w  #2,a0
        move.w  #40,a1
	ENDIF
	IFND ti89
        move.w  #7,a0
        move.w  #40,a1
	ENDIF
        bsr     putstr

        clr.w   d0
        move.b  LLemTot(a4),d0
        moveq   #12,d2
        lea     ltot(pc),a2
	IFD ti89
        move.w  #2,a0
        move.w  #50,a1
	ENDIF
	IFND ti89
        move.w  #7,a0
        move.w  #50,a1
	ENDIF
        bsr.s   putdec8a

        clr.w   d0
        move.b  LLemNe(a4),d0
        moveq   #12,d2
        lea     lnee(pc),a2
	IFD ti89
        move.w  #2,a0
        move.w  #70,a1
	ENDIF
	IFND ti89
        move.w  #7,a0
        move.w  #70,a1
	ENDIF
        bsr.s   putdec8a

	IFD ti89
        move.w  #92,a1
        move.w  #0,a0
	ENDIF
	IFND ti89
        move.w  #118,a1
        move.w  #5,a0
	ENDIF
        lea     pressh(pc),a2
        bsr     putstr

f12_l5: bsr     ScanKeys
	IFD ti89
        btst    #4,KeyStat(a6) ; 2nd
	ENDIF
	IFND ti89
        btst    #0,KeyStat(a6) ; Hand
	ENDIF
        beq     f12_l5
        bsr     ClearScreen
        rts

; d0 : number
; d2 : string length
; a0 : X
; a1 : Y
; a2 : string
; destroys d0/d1/a0/a2/a3

putdec8a:
        bsr     putstr
putdec8aa:
        lea     decn(pc),a3
        ; d0 num
        clr.l   d1
        move.b  d0,d1
        divu    #10,d1  ; low quo/ hi rem
        add.b   #48,d1
        move.b  d1,(a3)
        swap    d1      ; rem low
        add.b   #48,d1
        move.b  d1,1(a3)
        add.w   d2,a0
        move.l  a3,a2
        bsr     putstr
        rts

IScaletab:
	dc.b	0,0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0,0
	dc.b	2,10,18,26,33,40,46,52
	dc.b	58,63,67,71,74,78,82,85
	dc.b	87,89,91,93,95,97,98,99
	dc.b	100,100,100,100,100,100,100,100
	dc.b	100,100,100,100,100,100,100,100
	dc.b	100,100,100,100,100,100,100,100
	dc.b	99,98,97,95,93,91,89,87
	dc.b	85,82,78,74,71,67,63,58
	dc.b	52,46,40,33,26,18,10,2
	dc.b	0,0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0,0
	dc.b	0,0,0,0,0,0,0,0
IScalepos:
	dc.w	0


	IFD ti89
Itext1:
                ;  lemmings - a port by
	dc.b    '::F?GGCHAM:V:;:JILN:<R::',0
Itext2:
                ;   stephan effelsberg
	dc.b    ':::MN?JB;H:?@@?FM<?LA:::',0
Itext3:
                ;  alejandro p. schmidt
	dc.b    '::;F?D;H>LI:JU:M=BGC>N::',0
Itext4:
                ;  shift   command menu
	dc.b    '::MBC@N:::=IGG;H>:G?HO::',0
Itext5:
                ;  2nd     give command
	dc.b    '::2H>:::::ACP?:=IGG;H>::',0
Itext6:
                ;       press esc
	dc.b    ':::::::JL?MM:?M=::::::::',0
Itextlvl:
                ;  start with level 01      
        dc.b    'MN;LN:QCNB:F?P?F:01',0
	ENDIF

	IFND ti89
Itext1:
                ;lemmings - a ti port by
	dc.b    'F?GGCHAM:V:;:NC:JILN:<R:',0
Itext2:
                ;   stephan effelsberg
	dc.b    ':::MN?JB;H:?@@?FM<?LA:::',0
Itext3:
                ; alejandro paz schmidt
	dc.b    ':;F?D;H>LI:J;S:M=BGC>N::',0
Itext4:
                ;f1..f8    select command
	dc.b    '@1UU@8::::M?F?=N:=IGG;H>',0
Itext5:
                ;hand        give command
	dc.b    'B;H>::::::::ACP?:=IGG;H>',0
Itext6:
                ; press esc to continue
	dc.b    ':JL?MM:?M=:NI:=IHNCHO?::',0
Itextlvl:
                ;  start with level 01      
        dc.b    'MN;LN:QCNB:F?P?F:01',0
	ENDIF

	even

Intro:
 bsr	ClearScreen
 bsr    plemgrp

 move.w #0,a0   ; !@
 move.w #82,a1
 lea	Itextlvl(pc),a2
 move.b #'0',17(a2)
 move.b #'1',18(a2)
 bsr    putstr

Intromain:
 move.l hlplane0(a6),a0 ; instead of IBuf
 lea	Itext1(pc),a2
 bsr	Iputstr
 lea	24*8(a0),a0
 lea	Itext2(pc),a2
 bsr	Iputstr
 lea	24*8(a0),a0
 lea	Itext3(pc),a2
 bsr	Iputstr
 bsr.s  Introshow
 move.l hlplane0(a6),a0
 lea	Itext4(pc),a2
 bsr	Iputstr
 lea	24*8(a0),a0
 lea	Itext5(pc),a2
 bsr	Iputstr
 lea	24*8(a0),a0
 lea	Itext6(pc),a2
 bsr	Iputstr
 bsr.s  Introshow
 bra    Intromain

Introshow:
 lea	IScalepos(pc),a3
 clr.w	(a3)
IScaleIn:
 bsr    ScanKeys
 	IFD ti89
 btst	#0,KeyStat+1(a6) ; ESC  => exit
 bne.s  Introend
 btst	#0,KeyStat(a6) ; UP  => level +1
 beq.s  IScale_1
	ENDIF
	IFND ti89
 btst	#6,KeyStat(a6) ; ESC  => exit
 bne.s  Introend
 btst	#2,KeyStat(a6) ; UP  => level +1
 beq.s  IScale_1
	ENDIF
 move.w lemlvl@0001,d0
 cmp.w  curlvl(a6),d0
 beq.s  IScale_1
 addq.w #1,curlvl(a6)
 bra.s  IScale_lvl
IScale_1:
 	IFD ti89
 btst	#2,KeyStat(a6) ; DOWN  => level -1
	ENDIF
	IFND ti89
 btst	#4,KeyStat(a6) ; DOWN  => level -1
	ENDIF
 beq.s  IScale_2
 tst.w  curlvl(a6)
 beq.s  IScale_2
 subq.w #1,curlvl(a6)
IScale_lvl:
 lea    Itextlvl+17(pc),a2
 clr.l	d0
 move.w curlvl(a6),d0
 addq.w #1,d0
 divu   #10,d0
 add.b  #'0',d0
 move.b d0,(a2)+
 swap	d0
 add.b  #'0',d0
 move.b d0,(a2)
; move.l plane1(a6),a0    ; !@
; lea    82(a0),a0
 move.w #0,a0
 move.w #82,a1
 lea    Itextlvl(pc),a2
 bsr    putstr
IScale_2:
 move.w	(a3),d0
 lea	IScaletab,a2
 lea	0(a2,d0.w),a2
 bsr.s  IScaler
 add.w	#1,(a3)
 cmp.w	#8*12,(a3)
 bls	IScaleIn
 rts
Introend:
 addq.l	#4,sp
 rts

IScaler:
 move.b	#24,d1
 move.l hlplane0(a6),a0
 move.l	plane1(a6),a1
	IFD ti89
 lea	240*4+28(a1),a1
	ENDIF
	IFND ti89
 lea	240*6+2(a1),a1
	ENDIF

scaleloop:
; scale 3 long words to the left of the middle
 swap	d1
 move.b	#99,d1
 move.w	#3*32-1,d0
 move.l	(a0)+,d2
 move.l	(a0)+,d3
 move.l	(a0)+,d4
 clr.l	d5
 clr.l	d6
 clr.l	d7
scaleloopl:
 sub.b	(a2),d1
 bpl.s  norotl
 add.b	#100,d1
 roxl.l	#1,d4
 roxl.l	#1,d3
 roxl.l	#1,d2
 roxl.l	#1,d7
 roxl.l	#1,d6
 roxl.l	#1,d5
 bra.s  scaleloopl1
norotl:
 roxl.l	#1,d4
 roxl.l	#1,d3
 roxl.l	#1,d2
scaleloopl1:
 dbra	d0,scaleloopl
 move.l	d5,(a1)+
 move.l	d6,(a1)+
 move.l	d7,(a1)+
; scale 3 long words to the right of the middle
 move.b	#99,d1
 move.w	#3*32-1,d0
 move.l	(a0)+,d2
 move.l	(a0)+,d3
 move.l	(a0)+,d4
 clr.l	d5
 clr.l	d6
 clr.l	d7
scaleloopr:
 sub.b	(a2),d1
 bpl.s  norotr
 add.b	#100,d1
 roxr.l	#1,d2
 roxr.l	#1,d3
 roxr.l	#1,d4
 roxr.l	#1,d5
 roxr.l	#1,d6
 roxr.l	#1,d7
 bra.s  scaleloopr1
norotr:
 roxr.l	#1,d2
 roxr.l	#1,d3
 roxr.l	#1,d4
scaleloopr1:
 dbra	d0,scaleloopr
 move.l	d5,(a1)+
 move.l	d6,(a1)+
 move.l	d7,(a1)+
; next line
 addq.l	#1,a2
 lea	6(a1),a1
 swap	d1
 sub.b	#1,d1
 bne	scaleloop
; moveq.w #7,d0
;Ilvl:
; movem.l (a0)+,d1-d6
; movem.l d1-d6,(a1)
; lea    30(a1),a1
; dbf    d0,Ilvl
 rts

; in : a0 IBuf (+24*8 or +2*24*8)
;      a2 ptr to string
Iputstr:
        movem.l d0/a0-a2,-(a7)
                     
Iputstr1:
        clr.w   d0
        move.b  (a2)+,d0
        tst.b   d0
        beq.s   Iputstr2
        lea     charset(pc),a1
        sub.b   #48,d0  ; adjusted !
        lsl.w   #3,d0
	lea	0(a1,d0.w),a1

        move.b  (a1)+,(a0)
        move.b  (a1)+,24(a0)
        move.b  (a1)+,2*24(a0)
        move.b  (a1)+,3*24(a0)
        move.b  (a1)+,4*24(a0)
        move.b  (a1)+,5*24(a0)
        move.b  (a1)+,6*24(a0)
        move.b  (a1)+,7*24(a0)

        addq.l  #1,a0
        bra     Iputstr1
Iputstr2:
        movem.l (a7)+,d0/a0-a2
        rts
;
; displays a message about the last level done
; d0 : 2 : Start over
;      1 : time is up
;      0 : out of lems

tupscr: bsr     ClearScreen
        move.w  #48,a1
        move.w  #4,a0
        cmp.w   #2,d0
        beq.s   f22_l2
        lea     timeup(pc),a2
        tst.w   d0
        beq.s   f22_l1
        lea     outofl(pc),a2
f22_l1: bsr     putstr
f22_l2: move.w  #92,a1
        move.w  #0,a0
        lea     presse(pc),a2
        bsr     putstr

f22_l5: bsr     ScanKeys
        btst    #0,KeyStat+1(a6)
        beq     f22_l5
        bsr     ClearScreen
        rts

;
; shows the lem's graph under the intro demo
;
; compiles two different graphs for 89 and 92.

plemgrp:
        lea     lemgrp(pc),a0
        bsr     OpenArchive
        move.l  plane0(a6),a0
        IFD ti89               ; !@
        lea     20*30(a0),a0
        ENDIF
        clr.w   d1
        bsr     Extract        ; extracts to plane0 directly
        IFD ti89
        rts
        ENDIF
        IFND ti89
        lea     lemgrp(pc),a0
        bsr     OpenArchive
        move.l  plane0(a6),a0
        lea     74*30(a0),a0
        clr.w   d1
        bra     Extract        ; extracts to plane0 directly
        ENDIF

; ****************************************************************************
;
; Library support
;
; ****************************************************************************

GetLibInfo:
        move.w  curlvl(a6),d0
GetLibInfoD0:
        jsr     lemlvl@0000
        rts

; --------------------------------
;
;  Variables & Constants
;
; --------------------------------

mvar    dc.w    0,0,0   ; DON'T REMOVE OR SHRINK! see inigr4lib

	IFD ti89
                ;  time is up
timeup  dc.b    '::NCG?:CM::OJ::',0
                ;  out of lems
outofl  dc.b    '::ION:I@:F?GM::',0
                ; esc to start over
presse  dc.b    ':?M=:NI:MN;LN:IP?L',0
                ; press 2nd to begin
pressh  dc.b    ':JL?MM:2H>:NI:<?ACH',0
                ;total lems
ltot    dc.b    'NIN;F:F?GM',0,0
                ;lems needed
lnee    dc.b    'F?GM:H??>?>',0
	ENDIF

	IFND ti89
                ;  time is up
timeup  dc.b    '::NCG?:CM::OJ::',0
                ;  out of lems
outofl  dc.b    '::ION:I@:F?GM::',0
                ;press esc to start over
presse  dc.b    'JL?MM:?M=:NI:MN;LN:IP?L',0
                ;press hand to begin
pressh  dc.b    'JL?MM:B;H>:NI:<?ACH',0
                ;total lems
ltot    dc.b    'NIN;F:F?GM',0,0
                ;lems needed
lnee    dc.b    'F?GM:H??>?>',0
	ENDIF


stime   dc.b    '::W::',0
lin     dc.b    'CH',0,0
lout    dc.b    'ION',0

NameTab dc.b 58,58,58,58,58,58,58,0 ; 0 empty
        dc.b 64,59,70,70,63,76,58,0 ; 1 Faller
        dc.b 81,59,70,69,63,76,58,0 ; 2 Walker
        dc.b 62,67,65,65,63,76,58,0 ; 3 Digger
        dc.b 64,70,73,59,78,63,76,0 ; 4 Floater
        dc.b 64,70,73,59,78,63,76,0 ; 5 Floater(Lander)
        dc.b 58,58,58,58,58,58,58,0 ; 6 empty(Splasher)
        dc.b 61,70,67,71,60,63,76,0 ; 7 Climber
        dc.b 71,67,72,63,76,58,58,0 ; 8 Miner
        dc.b 60,79,67,70,62,63,76,0 ; 9 Builder
        dc.b 60,79,67,70,62,63,76,0 ; 10 Builder(Shrugger)
        dc.b 58,58,58,58,58,58,58,0 ; 11 empty
        dc.b 60,70,73,61,69,63,76,0 ; 12 Blocker
        dc.b 60,73,71,69,63,76,58,0 ; 13 Bomber
        dc.b 58,58,58,58,58,58,58,0 ; 14 empty
        dc.b 58,58,58,58,58,58,58,0 ; 15 empty
NameTabAth:
        dc.b 59,78,66,70,63,78,63,0 ; Athlete
NameTabCl:
        dc.b 61,70,67,71,60,63,76,0 ; Climber
NameTabFl:
        dc.b 64,70,73,59,78,63,76,0 ; Floater
       
        even

decn    dc.b    0,0,0,0

Cross:
        dc.b %00011000
        dc.b %00011000
        dc.b %00000000
        dc.b %11000011
        dc.b %11000011
        dc.b %00000000
        dc.b %00011000
        dc.b %00011000
Box:
        dc.b %11000011
        dc.b %10000001
        dc.b %00000000
        dc.b %00000000
        dc.b %00000000
        dc.b %00000000
        dc.b %10000001
        dc.b %11000011

Fx      dc.b    128,4,64,2,32,1,16,0,8,0
cmdtrig dc.b 0
	even

_comment     dc.b "Lemmings v0.5.1.2",0

        end

